#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_email.pl
#
# Version:  @(#)$Revision$
#
# Purpose:  
#
#   Specs: 
#
#  Author:  Bill Border
#
#    Note:  
# !*-------------------------------------------------------------------------

$P = "dbamon_email.pl";
$| = 1;
require "cgi_handlers.pl";

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

#---- Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

#---- Vars 
$debug       = 0;
$ss_med = "<span style='font-family:$font;font-size:9pt;'>"; 

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

use DBI;
require "cgi_handlers.pl";

#------------------------------------------------------------------------------
#
# Subs
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub displayData
#------------------------------------------------------------------------------
{
  &msg("displayData - Starting") if $debug;  
 
  $all_contacts  = ""; 
  $all_contacts .= "$sn_contact_tech," if $sn_contact_tech ne ""; 
  $all_contacts .= "$sn_contact_business," if $sn_contact_business ne ""; 
  $all_contacts .= "$sn_contact_owner," if $sn_contact_owner ne ""; 
  $all_contacts .= "$sn_ser_owner," if $sn_ser_owner ne ""; 
  chop $all_contacts; 

  print "<p>
$ss_med
  <table border=0 bgcolor=wheat>
    <tr bgcolor=lightsteelblue>
      <th>$ss_med &nbsp; Service-Now Field &nbsp; 
      <th>$ss_med Value - With Mailto: URL<br>(If Any) 

    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Instance Technical Contact: &nbsp;
      <td        $ss_med &nbsp; <b> <a href='mailto:$sn_contact_tech'>$sn_contact_tech</a></b>  &nbsp;
    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Instance Business Contact: &nbsp;
      <td>       $ss_med &nbsp; <b> <a href='mailto:$sn_contact_business'>$sn_contact_business</a></b>  &nbsp;
    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Instance Owner: &nbsp;
      <td        >$ss_med &nbsp; <b> <a href='mailto:$sn_contact_owner'>$sn_contact_owner</a></b>  &nbsp;
    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Server Owner: &nbsp;
      <td       >$ss_med &nbsp; <b> <a href='mailto:$sn_ser_owner'>$sn_ser_owner</a></b>  &nbsp;
    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Instance & Server All-Contacts: &nbsp;
      <td       >$ss_med &nbsp; <b> <a href='mailto:$all_contacts'>$all_contacts</a></b>  &nbsp;

    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Instance Support Group: &nbsp;
      <td       >$ss_med &nbsp; <b> <a href='mailto:$sn_support_group'>$sn_support_group</a></b>  &nbsp;

    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Instance Description: &nbsp;
      <td       >$ss_med &nbsp; <b> $sn_ins_desc </b> 

    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Server Description: &nbsp;
      <td       >$ss_med &nbsp; <b> $sn_ser_desc </b> 
    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Server SLA: &nbsp;
      <td       >$ss_med &nbsp; <b> $sn_ser_sla </b> 
    <tr bgcolor=snow>
      <td nowrap>$ss_med &nbsp; Server PCI &nbsp;
      <td       >$ss_med &nbsp; <b> $sn_ser_pci </b> 

  </table>\n"; 
  &msg("displayData - Done") if $debug; 
}

#------------------------------------------------------------------------------
sub selectInstances
#------------------------------------------------------------------------------
{
  &msg("selectInstances - Starting") if $debug; 

  $sql  = "SELECT 
       [ins_contact_tech]
      ,[ins_contact_owner]
      ,[ins_contact_business]
      ,[ins_support_group]
      ,[ins_desc]
  FROM dbamon.[dbamon].[sn_instances]
  WHERE
    ins_server = '$rmt_hostname' 
    and ins_instance = '$in_instance';";

  &msg("Reading from DBAmon Repository - sql=($sql)"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sn_contact_tech     = shift(@Data); 
    $sn_contact_owner    = shift(@Data); 
    $sn_contact_business = shift(@Data); 
    $sn_support_group    = shift(@Data); 
    $sn_ins_desc         = shift(@Data); 
    
    &msg("DEBUG - 
sn_contact_tech=($sn_contact_tech)
sn_contact_owner=($sn_contact_owner)
sn_contact_business=($sn_contact_business)
sn_support_group=($sn_support_group)
sn_ins_desc=($sn_ins_desc)
    ") if $debug;  

    $selectcount++;
  }

  &msg("selectInstances - Done - selectcount=$selectcount") if $debug; 
}

#------------------------------------------------------------------------------
sub selectServers
#------------------------------------------------------------------------------
{
  &msg("selectInstances - Starting") if $debug; 

  $sql  = "SELECT 
       [ser_sla]
      ,[ser_pci]
      ,[ser_owner]
      ,[ser_desc]
  FROM dbamon.[dbamon].[sn_servers]
  WHERE
    ser_server = '$rmt_hostname';";

  &msg("Reading from DBAmon Repository - sql=($sql)"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sn_ser_sla = shift(@Data); 
    $sn_ser_pci    = shift(@Data); 
    $sn_ser_owner = shift(@Data); 
    $sn_ser_desc    = shift(@Data); 
    
    $selectcount++;
  }

  &msg("selectServers - Done - selectcount=$selectcount") if $debug; 
}

#------------------------------------------------------------------------------
#
# Main  
# 
#------------------------------------------------------------------------------

@words = split(/,/,@ARGV[0]);
$rmt_hostname = @words[0];
$rmt_domain   = @words[1];
$rmt_title1   = @words[2];
$in_instance  = @words[3];

$zclient = $ENV{'REMOTE_HOST'};

#---- Display html header
&header("Email Instance Contacts");
&msg("Starting - system=$rmt_hostname in_instance=$in_instance");

#---- Connect to DBAmon repository
&connectDB; 

#---- Read from SN_Instances
&selectInstances;

#---- Read from SN_Instances
&selectServers;

#---- Display the results 
&displayData;

#---- Terminate
print "<hr>\n"; 
&msg("Done"); 
exit 0;
