#!/usr/local/bin/perl
$ENV{"PATH"} .= "$ENV{'PATH'}:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#
#    Name:  dbamon_rpt.pl
#
# !*-------------------------------------------------------------------------

$P = "dbamon_rpt";
$| = 1;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

use DBI;
require "cgi_handlers.pl";

#---- Vars
$SIG{'INT'} = 'IntHandler';
$rqpairs{'dbms'} = ""; 
$date          = `date`;

#---- Read font
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;

$maxrows = 500; 
$dtprevent = ""; 
$dtdesc    = ""; 

$fs = "<font size=2>"; 
$ss_med = "<span style='font-family:$font;font-size:9pt;'>";

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "</table><hr>";
   print "<h4> The following database error occured:</h4>";
   print "    <b> Error ID: </b> $errorMsg";
   $sqlerror = $DBI::errstr;
   print "<br><b>SQL Statement: </b> <pre> $statement </pre>";
   print "<br><b>SQL Error: </b> $sqlerror";
   print "<hr>";

   exit(1);
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=white";
  }
  else
  {
    $lastbg = 1;
    #return "bgcolor=lightgrey";
    return "bgcolor=#dcdcdc";
    #return "bgcolor=palegoldenrod";
  }
}

#-----------------------------------------------------------------------------
sub report_text
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $days = $arg1;

  # Create the SQL SELECT statement
  $statement  = "select
    system,
    instance,
    text,
    to_char(ts,'YYYY/MM/DD-HH24:MI:SS')
  from 
    dbamon.text
  where 
    ts >= (sysdate - $days)
  order by 
    system, 
    instance, 
    seq";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  print "<h4>DBAmon Text Entries That Have Changed Within The Last $days Day(s)</h4>\n";
  print "<table border=1>\n";
  #print "
  #<tr bgcolor=slate> 
  #  <th><h6>System-Instance 
  #  <th><h6>Text
  #";

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $system   = $Data[0];
    $instance = $Data[1];
    $text     = $Data[2];
    $ts       = $Data[3];

    $title1 = $system . "-" . $instance;
    $title1 =~ s/ //g;

    if ($title1 ne $last_title1)
    {
      print "
      <tr bgcolor=black>
	<td colspan=4><h5><center><font color=lightblue>Instance: $title1</font></center>";
	#<td colspan=4><h5><center>Instance: $title1</center>";
    }

    #print "system=$system instance=$instance text=$text ts=$ts\n";
      #<td bgcolor=lightblue nowrap><h6>$title1
    print "
    <tr bgcolor=lightgrey>
      <td bgcolor=wheat><h5>$text
      ";
    $last_title1 = $title1; 
  }
  print" </table> \n";
  print "<p><font size=1>(Selected $selectcount Rows)</font><hr>";
}

#-----------------------------------------------------------------------------
sub report_testrpt
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $days = $arg1;

  # Create the SQL SELECT statement
  $statement  = "
select
  distinct
  sd.system ,
  sd.rmt_domain,
  sd.title ,
  sd.dbms ,
  sd.id2 ,
  i.os
from
  dbamon.summary_detail sd,
  dbamon.instances      i
where
  sd.system = i.system
  and id5 = 'Avago'
order by
  1 ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  print "<table border=1>\n";
  #print "
  #<tr bgcolor=slate> 
  #  <th><h6>System-Instance 
  #  <th><h6>Text
  #";
  print "<tr bgcolor=slate><th>Server<th>Domain<th>Server:Instance<th>DBMS<th>App<th>OS
  "; 

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $c1   = $Data[0];
    $c2   = $Data[1];
    $c3   = $Data[2];
    $c4   = $Data[3];
    $c5   = $Data[4];
    $c6   = $Data[5];

    print "
    <tr bgcolor=lightgrey>
      <td>$c1
      <td>$c2
      <td>$c3
      <td>$c4
      <td>$c5
      <td>$c6
      ";
  }
  print" </table> \n";
  &msg("(Selected $selectcount Rows)");
}

#-----------------------------------------------------------------------------
sub report_testrpt2
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $days = $arg1;

  # Create the SQL SELECT statement
  $statement  = "
select
    ticket_type,
    ticket_id,
    to_char(create_time,'YYYY/MM/DD-HH24:MI:SS') create_time,
    server,
    description,
    status,
    work_group,
    origin
  from
    ovsddata.tickets
  where
  (work_group like '%HOSTING-WEBINFRA-DBMSSQL%' or
   work_group like '%HOSTING-WEBINFRA-DBORACLE%' or
   work_group like '%HOSTING-WEBINFRA-DBINFORMIX%' or
   work_group like '%HOSTING-WEBINFRA-DBSAP%' or
   work_group like '%HOSTING-WEBINFRA-DBCOREFOLLOWUP%')
  --and create_time > to_date('2004/02/25-08:30:00','YYYY/MM/DD-HH24:MI:SS')
  and create_time > to_date('2006/06/01-00:00:00','YYYY/MM/DD-HH24:MI:SS')
  and upper(description) like '%BACKUP%'
  and ticket_type = 'IN'
  and origin != 'DBAmon'
  order by
    2, 3 
   ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  print "<table border=1>\n";
  #print "
  #<tr bgcolor=slate> 
  #  <th><h6>System-Instance 
  #  <th><h6>Text
  #";
  print "<tr bgcolor=slate>
    <th>$fs OVSD<br>Incident
    <th>$fs Created
    <th>$fs Server
    <th>$fs Desc
    <th>$fs Status
    <th>$fs Team
    <th>$fs Tool
  "; 

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $c1   = $Data[0];
    $c2   = $Data[1];
    $c3   = $Data[2];
    $c4   = $Data[3];
    $c5   = $Data[4];
    $c6   = $Data[5];
    $c7   = $Data[6];
    $c8   = $Data[7];
    $c9   = $Data[8];

    print "
    <tr bgcolor=lightgrey>
      <td>$fs $c2
      <td>$fs $c3
      <td>$fs $c4
      <td>$fs $c5
      <td>$fs $c6
      <td>$fs $c7
      <td>$fs $c8
      <td>$fs $c9
      ";
  }
  print" </table> \n";
  &msg("(Selected $selectcount Rows)");
}

#-----------------------------------------------------------------------------
sub report_testrpt3
#-----------------------------------------------------------------------------
{
  &msg("Creating report"); 

  $days = $arg1;

  # Create the SQL SELECT statement
  $sql  = "
select
    to_char(create_time,'YYYY/MM'), 
    person,
    count(*) 
  from
    ovsddata.tickets
  where
    (work_group like '%HOSTING-WEBINFRA-DBMSSQL%' or
     work_group like '%HOSTING-WEBINFRA-DBORACLE%' or
     work_group like '%HOSTING-WEBINFRA-DBINFORMIX%' or
     work_group like '%HOSTING-WEBINFRA-DBSAP%' or
     work_group like '%HOSTING-WEBINFRA-DBCOREFOLLOWUP%')
    and create_time > to_date('2007/01/01-00:00:00','YYYY/MM/DD-HH24:MI:SS')
    and status = 'Closed' 
  group by 
    to_char(create_time,'YYYY/MM'), 
    person
  order by
    1 desc, 2 
   ";

  &msg("sql=$sql"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  &msg("Report done"); 

  print "<table border=1>\n";
  #print "
  #<tr bgcolor=slate> 
  #  <th><h6>System-Instance 
  #  <th><h6>Text
  #";
  print "<tr bgcolor=slate>
    <th>$fs Month
    <th>$fs Person 
    <th>$fs Count
  "; 

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $c1   = $Data[0];
    $c2   = $Data[1];
    $c3   = $Data[2];
    $c4   = $Data[3];
    $c5   = $Data[4];
    $c6   = $Data[5];
    $c7   = $Data[6];
    $c8   = $Data[7];
    $c9   = $Data[8];

    print "
    <tr bgcolor=lightgrey>
      <td>$fs $c1
      <td>$fs $c2
      <td>$fs $c3
      <td>$fs $c4
      <td>$fs $c5
      <td>$fs $c6
      <td>$fs $c7
      <td>$fs $c8
      <td>$fs $c9
      ";
  }
  print" </table> \n";
  &msg("(Selected $selectcount Rows)");
}

#-----------------------------------------------------------------------------
sub report_serverList
#-----------------------------------------------------------------------------
{
  $dbms = $rqpairs{'dbms'}; 
  &msg("Creating Server List - DBMS: $dbms"); 

  $statement  = "
    select
      distinct
      sd.rmt_hostname,
      sd.rmt_domain
    from
      dbamon.summary_detail sd
    where   
      dbms = '$dbms'
      and rmt_hostname != '?'
      and rmt_hostname != '.'
    order by 1 ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  print "<p><table border=1 bgcolor=linen>\n";
  print "<tr bgcolor=steelblue><th><font size=2>Server Names 
  <tr><td><font size=2>\n"; 

  while (@Data = $sth->fetchrow_array)
  {
    $hostname = $Data[0];
    $domain   = $Data[1];
    $thisserver = "$hostname.$domain"; 
    #print "<tr><td><font size=2>$thisserver \n"; 
    print "$thisserver &nbsp; &nbsp; \n"; 
    $selectcount++; 
  }

  print" </table> \n";
  &msg("(Selected $selectcount Rows)");
}

#-----------------------------------------------------------------------------
sub report_SLA_old
#-----------------------------------------------------------------------------
{
  &msg("Creating SLA Report");
  print "
<hr>
<p><table bgcolor=#8E2323><th><font color=white><font size=2>1. DB Instance Count (DBAmon)</table><p>
<iframe style='background: black' src='/cgi-bin/dbamon_rpt.pl?prod,bill' width=90% height=40%></iframe>
<p>

<hr>
<p><table bgcolor=#8E2323><th><font color=white><font size=2>2. DB Instance Availability (DBAmon)</table><p>
<p>
<iframe style='background: black' src='/cgi-bin/dbamon_rpt.pl?prod,uptime3' width=90% height=40%></iframe>
<p>
  ";
}

#-----------------------------------------------------------------------------
sub report_SLA
#-----------------------------------------------------------------------------
{
  &msg("SLA Report Menu");
  print "
<hr>

<h4>SLA Reports</h4>
<ol>
  <b><li><font size=2>
    <a href='/cgi-bin/dbamon_rpt.pl?prod,bill'><b>DB Instance Count</a></b>
  <b><li><font size=2>
    <a href='/cgi-bin/dbamon_sla_report.pl'><b>DB Instance Availability & DB Backup Success</a></b>
</ol>

<h4>SLA Maintenace</h4>
<ol start=3>
  <b><li><font size=2>
    <a href='/cgi-bin/dbamon_sla_report.pl?Review,All'><b>Review/Update Downtime</a></b> (Under Construction)
</ol>
  ";
}

#-----------------------------------------------------------------------------
sub report_serverListMenu
#-----------------------------------------------------------------------------
{
  &msg("Creating serverListMenu");

  $days = $arg1;

  # Create the SQL SELECT statement
  $statement  = "
    select
      distinct
      sd.dbms
    from
      dbamon.summary_detail sd
    where
      dbms != '(ServerAlias)'
    order by 1 ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  chop($d = `date`);

  while (@Data = $sth->fetchrow_array)
  {
    $dbms = $Data[0];
    push (@dbmslist, $dbms); 
    $selectcount++; 
  }

  &msg("(Selected $selectcount Rows)");

  print "
    <FORM method='POST' action='/cgi-bin/dbamon_rpt.pl?$dbamonmode,serverListReport'>
    <HR>\n";

  print "<table border=0>
    <tr bgcolor=lightblue>
      <th bgcolor=steelblue> <font face=$font size=2>Click One DBMS &nbsp<br>Then Click 'Create Report':
      <td width=40%>
   ";

  foreach $dbms (@dbmslist)
  {
    print "<input name=dbms type=radio value=$dbms><b><font size=2>$dbms</b><br>\n";
  }

  print " 
    </table><p> 
    <td>&nbsp;&nbsp;&nbsp;   <INPUT type=submit value='&gt;&gt; Create Report '></b>
    <p><hr>
  "; 

  exit;
}


#-----------------------------------------------------------------------------
sub report_oraservers
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "select
     system,
     count(*) 
   from
     dbamon.instances
   where
     dbamonmode like 'prod%'
     and dbms = 'Oracle'
   group by
     system
   order by 1
      ";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<table border=1> \n";
  print "<tr bgcolor=slate><th><h6>Server<th><h6>Instance<br>Count\n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $system   = $Data[0];
    $count    = $Data[1];

    $total_count += $count;

    print "<tr ><td><b><font size=2>$system<font><td align=right><font size=2>$count</font>\n";
  }

  print "<tr bgcolor=slate><td><b><font size=2>Total:<font><td align=right><font size=2><b>$total_count</b></font>\n";
  print "</table> \n";

  print "<font size=2><p><b>Total Servers Housing Oracle/UX Instances: $total</b></font>";
  
  print "</table> \n";
}

#-----------------------------------------------------------------------------
sub report_cpucount
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  $mode = "prod";
  print "<font size=1>$d - Creating Report (mode=$mode)...</font>\n";

  $sql = "
    select
      dbms,
      count(*) servercount,
      sum(a.cpucount)
    from
      (select distinct
	 dbms,
	 fqhostname,
	 cpucount
       from
	 dbamon.instances
       where
	 cpucount is not null
         and dbamonmode like '${mode}%') a
    group by
      dbms
  ";
  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<table border=1 bgcolor=linen> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>DBMS
    <th><font size=2>Total Server Count
    <th><font size=2>Total CPU Count
  \n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $dbms        = $Data[0];
    $servercount = $Data[1];
    $cpucount    = $Data[2];

    $total_server_count += $servercount;
    $total_cpu_count    += $cpucount;

    print "<tr>
      <td><font size=2>$dbms</font>
      <td align=right><font size=2>$servercount</font>
      <td align=right><font size=2>$cpucount</font>
    \n";
  }

  print "<tr bgcolor=slate>
    <td><b><font size=2>Total:<font>
    <td align=right><font size=2><b>$total_server_count</b></font>
    <td align=right><font size=2><b>$total_cpu_count</b></font>
  \n";
  print "</table> \n";
}

#-----------------------------------------------------------------------------
sub osclientInstances
#-----------------------------------------------------------------------------
{
  my $in_server = $_[0];

  $sql2 = "
    select distinct 
      i.instance 
    from
      dbamon.instance_details d,
      dbamon.instances i
    where
      d.instance_key = i.instance_key
      and i.system = '$in_server' 
      and d.category = 'Network'
      and d.parm = '192'
      and i.instance not in ('OPR1','PPR1','WPR1')
    order by
      1
  ";

  $sth2 = $dbh->prepare($sql2) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

  my $instance_list = ""; 

  while (@Data = $sth2->fetchrow_array)
  {
    $instance_list .= "$Data[0] "; 
  }
  
  return $instance_list;
}

#-----------------------------------------------------------------------------
sub checkTasks
#-----------------------------------------------------------------------------
{
  # See if all tasks have completed the first iteration - if not, then die

  $statement  = "
    select
      dbamonmode,
      max(iter_num),
      avg(iter_dur)
    from
      dbamon.task
    where
      dbamonmode like '${mode}%'
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $tasks_starting = 0;
  $tasks_count    = 0;

  $i_mode   = ""; 
  $avg_iter = ""; 

  while (@Data = $sth->fetchrow_array)
  {
    $tasks_count++;
    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    ##print "task=$i_mode maxiter=$i_num\n";

    if ($i_num < 1)
    {
      $taskflag3 = 1;
      $tasks_starting++;
    }
  }

  if ($taskflag3)
  {
    &msg("<font color=darkred>DBAmon is now in the process of restarting after an outage - $tasks_starting/$tasks_count Tasks Starting - taskflag3=$taskflag3 tasks_count=$tasks_count tasks_starting=$tasks_starting</font>");
    &msg("<font color=darkred>DBAmon is rarely restarted, but this report cannot be created until the DBAmon restart is complete - Please try again later (within 1 hour)</font>");
    return 1;
  }
}

#-----------------------------------------------------------------------------
sub checkDB
#-----------------------------------------------------------------------------
{
  $checkdb_debug = 0;

  $sql  = "
    select
      count(*) 
    from
      dbamon.instances
    where
      dbamonmode like '${mode}%'
      and dbms != '(ServerAlias)'
  ";
  &msg("DEBUG - sql=$sql") if $checkdb_debug; 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $num_detail_instances = $Data[0];
  }
  &msg("DEBUG -There are $num_detail_instances instances from dbamon.instances") if $checkdb_debug;

  # Now count the number of rows in the tasks table for iteration 0.
  # If the number of detail rows != the sum from the summary_dbms table,
  # then an update must be happening now!

  $sql  = "
    select
      sum(count)
    from
      dbamon.summary_dbms
    where
      dbamonmode like '${mode}%'
    ";
  &msg("DEBUG - sql=$sql") if $checkdb_debug; 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $num_dbms_instances = $Data[0];
  }
  &msg("DEBUG - There are $num_dbms_instances instances from the dbamon.summary_dbms table") if $checkdb_debug;

  if ($num_detail_instances != $num_dbms_instances)
  {
    &msg("<font color=darkred><u>DBAmon DB is being updated now - $num_detail_instances/$num_dbms_instances - Sleeping $sleeptime seconds - Please wait... ($sleepcnt)</u></font>");
    return 1;
  }
  &msg("DBAmon DB is consistent - $num_detail_instances/$num_dbms_instances");
  return 0;
}

#-----------------------------------------------------------------------------
sub report_bill
#-----------------------------------------------------------------------------
{
  system("echo '' | mailx -s 'monitor--$P $report ($ENV{'REMOTE_HOST'}) [AUTO]' border\@crud.com");
  $mode = "prod";

  &msg("Checking DBAmon task status");
  return if &checkTasks == 1; 

  $sleeptime = 20;
  $sleepcnt  = 1;  

  &msg("Checking DBAmon Repository for consistency");
  while  ( &checkDB == 1) 
  {
    sleep $sleeptime;
    $sleepcnt++; 
  } 

  system("echo '' | mailx -s 'monitor--$P report_bill ($ENV{'REMOTE_HOST'}) sleepcnt=$sleepcnt [AUTO]' border\@crud.com") if $sleepcnt > 10;

  $exclude_id3_list = "'Oracle-AMS','LSCA-SAP','HP-Avago-Ifmx'"; 

  print "
  <hr> <h5>Report Menu:</h5>
  <font size=2>
  <ol>
    <li><a href='#report_Network'>  <b>By Server Network Location</b></a>
    <li><a href='#report_ID8'>      <b>By Server Delivery Level</b></a>
    <li><a href='#report_Instances'><b>DB Instance Detail</b></a>
  </ol>
  <table border=1 bgcolor=pink bordercolor=black>
    <th>&nbsp; <font color=darkred size=2>Note: If you right-click on any of the report tables that
  you see below, you can then export the table data to Excel.&nbsp; </table><p>
  "; 

  &report_bill_ByNetwork;
  $save_total_instance_count = $total_instance_count;

  &report_bill_ByID8;
  &report_bill_ByInstance;
}

#-----------------------------------------------------------------------------
sub report_bill_ByID8
#-----------------------------------------------------------------------------
{
  print "</center><hr>\n";
  &msg("Creating Billing Report - By STAR Server Delivery Level");

  $sql = "
    select
      nvl(id8,'(Null)'), 
      count(*) 
    from
      dbamon.summary_detail 
    where
      (id3 is null or id3 not in ($exclude_id3_list))
      and dbamonmode like '${mode}%' 
      and dbms != '(ServerAlias)'
    group by
      nvl(id8,'(Null)')
  ";
  &msg("sql=$sql"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("Report Complete<p>");

  $selectcount = 0;

  print "<font face='$font'>\n";

  print "<hr><center><a name='report_ID8'>\n";
  print "<h3>DB Instance Count Report - By STAR Server Delivery Level</h3>\n";
  print "<h4>ID3 (Support Organization) Values Excluded: $exclude_id3_list</h4>\n";

  print "<font face='myriad web'><p><table border=0 bgcolor=linen> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>Line
    <th><font size=2>Server<br>Delivery<br>Level
    <th><font size=2>DB<br>Instance<br>Count
    <th colspan=2><font size=2>% Of<br>Total<br>DB Instances
  \n";

  $line_num = 0;
  $total_instance_count = 0; 

  while (@Data = $sth->fetchrow_array)
  {
    $line_num++;

    $id8          = shift @Data;
    $instance_cnt = shift @Data;

    $total_instance_count += $instance_cnt;

    #if ($id3 && index($exclude_id3_list,$id3) > -1) 
    #{
    #  $exclude_cnt += $instance_cnt; 
    #  next; 
    #}

    $pct = ($instance_cnt / $save_total_instance_count) * 100;
    $pct = sprintf("%.2f",$pct);
    
    $zwidth = $pct * 2;

    $bg = &bg;
    print "<tr $bg>
      <td>            <font size=2><u>$line_num</u></font>
      <td>            <font size=2><b>$id8</font></b>
      <td align=right><font size=2><b>$instance_cnt</font></b>
      <td align=right><font size=2><b>${pct}%</font></b>
      <td><img src='/images/blue.gif' height=15 width=$zwidth>
    \n";

  }

  print "<tr bgcolor=slate>
    <td>
    <td><b><font size=2>Total DB Instances:<font>
    <td align=right><font size=2><b>$total_instance_count</b></font>
    <td>&nbsp;
    <td>&nbsp;
  \n";
  print "</table>\n";
  print "<b><p><font size=2>Right-Click anywhere on the above table to export to Excel (if using you are using IE)</b>\n"; 
  print "<p> \n";
}

#-----------------------------------------------------------------------------
sub report_bill_ByNetwork
#-----------------------------------------------------------------------------
{
  print "</center><hr>\n";
  &msg("Creating Billing Report - By Network Location");

  $sql = "
    select
      nvl(serverloc,'(Null)'), 
      count(*) 
    from
      dbamon.summary_detail 
    where
      (id3 is null or id3 not in ($exclude_id3_list))
      and dbamonmode like '${mode}%' 
      and dbms != '(ServerAlias)'
    group by
      nvl(serverloc,'(Null)')
  ";
  &msg("sql=$sql"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("Report Complete<p>");

  print "<font face='$font'>\n";

  print "<hr><center><a name='report_Network'>\n";
  print "<h3>DB Instance Count Report - By Network Location</h3>\n";
  print "<h4>ID3 (Support Organization) Values Excluded: $exclude_id3_list</h4>\n";

  print "<font face='myriad web'><p><table border=0 bgcolor=linen> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>Line
    <th><font size=2>Server<br>Network<br>Location
    <th><font size=2>DB<br>Instance<br>Count
  \n";

  $line_num = 0;
  $total_instance_count = 0; 

  while (@Data = $sth->fetchrow_array)
  {
    $line_num++;

    $serverloc    = shift @Data;
    $instance_cnt = shift @Data;

    $total_instance_count += $instance_cnt;

    #if ($id3 && index($exclude_id3_list,$id3) > -1) 
    #{
    #  $exclude_cnt += $instance_cnt; 
    #  next; 
    #}

    $bg = &bg;
    print "<tr $bg>
      <td>            <font size=2><u>$line_num</u></font>
      <td>            <font size=2><b>$serverloc</font></b>
      <td align=right><font size=2><b>$instance_cnt</font></b>
    \n";

  }

  print "<tr bgcolor=slate>
    <td>
    <td><b><font size=2>Total DB Instances:<font>
    <td align=right><font size=2><b>$total_instance_count</b></font>
  \n";
  print "</table>\n";
  print "<b><p><font size=2>Right-Click anywhere on the above table to export to Excel (if using you are using IE)</b>\n"; 
  print "<p> \n";
}

#-----------------------------------------------------------------------------
sub reportHealth
#-----------------------------------------------------------------------------
{
  print "</center>\n";

  ##system("echo '' | mailx -s 'monitor--$P $report ($ENV{'REMOTE_HOST'})' border\@crud.com");

  $histfile = "/opt/dbamon/dat/history/health_$dbamonmode.txt";

  &msg("Creating Global Health Report - mode=$dbamonmode histfile=$histfile");

  open(HEALTH, "cat $histfile| /usr/bin/sort -r |") || &error("Cannot open input $histfile - $!");

  #<center>
  print "
<font face='$font'>
<hr>
<a name='report_Network'>
<h3>DBAmon Health History</h3>
<font face='myriad web'><p><table border=0 bgcolor=linen> 
<tr bgcolor=slate>
    <th><font size=2>Timestamp<br>(YYYY/MM/DD-HH)
    <th colspan=1><font size=2> &nbsp; Total Instance Count &nbsp;
    <th colspan=2><font size=2>Health Value 
  \n";

  $max_health = 0; 
  $line_num = 0; 

  while(<HEALTH>)
  {
    @words = split; 

    $line_num++;

    $idate   = shift @words;
    $crud    = shift @words;
    $health  = shift @words;
    $crud    = shift @words;
    $count   = shift @words;

    ##&msg("DEBUG - date=$date health=$health count=$count"); 
    ##$zcount = $count / 6; 

    if    ($health >= 90) { $color = "green";    $bgcolor = "lime" }
    elsif ($health >= 80) { $color = "#99cc00";  $bgcolor = "#99cc00" }
    elsif ($health >= 70) { $color = "#ffff00";  $bgcolor = "#ffff00" }
    elsif ($health >= 60) { $color = "#ff9900";  $bgcolor = "#ff9900" }
    else                  { $color = "red";      $bgcolor = "pink"; }

    ##$zhealth = ($health - 85) * 25;
    $zhealth = $health;
    $zhealth = 1 if $zhealth <= 0; 

    $bg = &bg;
    print "<tr $bg>
      <td >            <font size=2><b>$idate</b></font>
      <td align=right bgcolor=$bgcolor><font size=2><b>$count</font></b>
      <td align=right bgcolor=$bgcolor><font size=2><b>$health</font></b>
    ";
    #---- This was only causing problems
    ##  <td ><img src='/dbamon/img/$color.gif' height=15 width=$zhealth>

    if ($health > $max_health)
    {
      $max_health = $health;
      $max_date = $idate;
    }
  }

  close(HEALTH); 

  print "</table>\n";
  print "<p></center> \n";

  &msg("Maximum Health Value: $max_health at $max_date - Read $line_num records from $histfile");
}

#-----------------------------------------------------------------------------
sub report_bill_ByInstance
#-----------------------------------------------------------------------------
{
  print "</center><hr>\n";
  &msg("Creating Billing Report - By Network Location");

  $sql = "
    --select distinct
    select 
      title,
      nvl(serverloc,'(Null)'), 
      dbms,
      id7,
      id8,
      rmt_hostname
    from
      dbamon.summary_detail 
    where
      (id3 is null or id3 not in ($exclude_id3_list))
      and dbamonmode like '${mode}%' 
      and dbms != '(ServerAlias)'
    order by
      1, 2
  ";
  &msg("sql=$sql"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("Report Complete<p>");

  $selectcount = 0;

  print "<font face='$font'>\n";

  print "<hr><center><a name='report_Instances'>\n";
  print "<h3>DB instance Detail Report</h3>\n";
  print "<h4>ID3 (Support Organization) Values Excluded: $exclude_id3_list</h4>\n";

  print "<font face='myriad web'><p><table border=0 bgcolor=linen> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>Line
    <th><font size=2>Server
    <th><font size=2>Instance
    <th><font size=2>DB<br>Server<br>Location
    <th><font size=2>Server<br>Support<br>Team
    <th><font size=2>Server<br>Support<br>Delivery Level
    <th><font size=2>DBMS
  \n";

  $line_num = 0;
  $total_instance_count = 0; 

  while (@Data = $sth->fetchrow_array)
  {
    $line_num++;

    $title          = shift @Data;
    $serverloc      = shift @Data;
    $dbms           = shift @Data;
    $os_supt_team   = shift @Data;
    $delivery_level = shift @Data;
    $rmt_hostname   = shift @Data;

    #---- Old way
    #$server   = (split('\:',$title))[0];
    #---- New way
    $server   = $rmt_hostname if $rmt_hostname; 

    $instance = (split('\:',$title))[1];

    $total_instance_count ++;

    $dbms_color = "black";
    $dbms_color = "green" if $dbms =~ /^MSSQL/; 
    $dbms_color = "red"   if $dbms =~ /^Oracle/; 
    $dbms_color = "blue"  if $dbms =~ /^Informix/; 

    $bg = &bg;
    print "<tr $bg>
      <td>            <font size=2><u>$line_num</u></font>
      <td>            <font size=2><b>$server</font></b>
      <td>            <font size=2><b>$instance</font></b>
      <td>            <font size=2><b>$serverloc</font></b>
      <td>            <font size=2><b>$os_supt_team</font></b>
      <td>            <font size=2><b>$delivery_level</font></b>
      <td>            <font size=2 color=$dbms_color><b>$dbms</font></b>
    \n";

  }

  #  print "<tr bgcolor=slate>
  #    <td>
  #    <td><b><font size=2>Total DB Instances:<font>
  #    <td align=right><font size=2><b>$total_instance_count</b></font>
  #  \n";
  print "</table>\n";
  print "<b><p><font size=2>Right-Click anywhere on the above table to export to Excel (if using you are using IE)</b>\n"; 
  print "<p> \n";
}

#-----------------------------------------------------------------------------
sub report_osclient
#-----------------------------------------------------------------------------
{
  $mode = "prod";

  &msg("Creating osclient report");
  &msg("This report is a sample of the server names which have DB connections from"); 
  &msg("client servers which are on the 192 network (OPR1/PPR1/WPR1 excluded)."); 

  $sql = "
    select distinct 
      i.system, 
      i.model,
      i.cpucount
    from
      dbamon.instance_details d,
      dbamon.instances i
    where
      d.instance_key = i.instance_key
      and d.category = 'Network'
      and d.parm = '192'
      and i.instance not in ('OPR1','PPR1','WPR1')
    order by
      i.system,
      i.model
  ";
  &msg("sql=$sql"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("Report Complete");

  $selectcount = 0;
  print "<font face='myriad web'><p><table border=0 bgcolor=linen> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>Server<br> Name
    <th><font size=2>Server<br> Model
    <th><font size=2>Server<br> CPU Count
    <th><font size=2>Instance(s) With Network 192 Connection(s)
  \n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $server    = $Data[0];
    $model     = $Data[1];
    $cpucount  = $Data[2];
    #$in_key    = $Data[3];

    $total_server_count ++;
    $total_cpu_count    += $cpucount;

    $bg = &bg;
    print "<tr $bg>
      <td><font size=2>$server</font>
      <td align=right><font size=2>$model</font>
      <td align=right><font size=2>$cpucount</font>
    \n";

    #---- find the instances for this server which have clients from 192
    $instances = &osclientInstances($server);
    print "<td><font size=2>$instances"; 
  }

  print "<tr bgcolor=slate>
    <td><b><font size=2>Total:<font>
    <td align=right><font size=2><b>$total_server_count (Servers)</b></font>
    <td align=right><font size=2><b>$total_cpu_count</b></font>
    <td>&nbsp;
  \n";
  print "</table> \n";
}

#-----------------------------------------------------------------------------
sub report_oradbs
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "select
     trim(misc3) m3,
     trim(system) || '_' || trim(instance) inst,
     trim(dbmsver) ver,
     misc1
   from
     dbamon.instances
   where
     dbamonmode like 'prod%'
     and dbms = 'Oracle'
     and misc3 is not null
     --and misc1 = 'bkRMAN' and dbmsver like '8.1%'
   order by 1, 2
      ";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<table border=0> \n";
  print "<tr bgcolor=slate><th>DBID<th>Instance<th>Oracle Version<th>Backup Type<th>Duplicate?\n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $dbid     = $Data[0];
    $instance = $Data[1];
    $ver      = $Data[2];
    $bktype   = $Data[3];

    if ($dbid eq $last_dbid)
    {
      $msg = "<b><font color=red>Duplicate</b></font>"; 
    }
    else
    {
      $msg = ""; 
    }

    print "<tr ><td><b>$dbid <td>$instance <td>$ver <td>$bktype <td>$msg\n";

    $last_dbid = $dbid;
  }

  print "<tr ><td colspan=3><hr> \n";
  print "Total Oracle/UX Instances: $total \n";
  
  print "</table> \n";
}


#-----------------------------------------------------------------------------
sub report_oraver7
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "select
     trim(system) || '_' || trim(instance) inst,
     trim(dbmsver) ver,
     dbms
   from
     dbamon.instances
   where
     dbamonmode like 'prod%'
     and dbms like 'Oracle%'
     and dbmsver like '7%'
   order by 1, 2
      ";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<table border=0> \n";
  print "<tr bgcolor=slate><th>Instance<th>Oracle Version<th>DBMS\n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $instance = $Data[0];
    $ver      = $Data[1];
    $dbms     = $Data[2];

    print "<tr ><td><b><font size=2>$instance <td><font size=2>$ver <td><font size=2>$dbms\n";
  }

  print "<tr ><td colspan=3><hr> \n";
  print "<font size=2>Total Oracle/UX Version 7 Instances: $total \n";
  
  print "</table> \n";
}

#-----------------------------------------------------------------------------
sub report_gov1
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  &msg("Selecting data from DBAMON.TICKET_GOVERNOR ...");

  system("echo '' | mailx -s 'monitor--$P ($ENV{'REMOTE_HOST'}) [AUTO]' border\@crud.com");

  $date_format = "YYYYMMDD-HH24";

  if ($dbamon_repos eq "O") 
  {
    $statement  = "
      select
	to_char(ts, '$date_format'),
	count(*)
      from
	dbamon.ticket_governor
      group by 
	to_char(ts, '$date_format')
      order by 
	to_char(ts, '$date_format')
      ";
  }
  else
  {
    $statement  = "
      select
	--to_char(ts, '$date_format'),
	dbamon.dateconvert_19(ts,),
	count(*)
      from
	dbamon.ticket_governor
      group by 
	dbamon.dateconvert_19(ts)
      order by 
	dbamon.dateconvert_19(ts)
      ";
  }

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = $Data[0];
    $count = $Data[1];
    $mrvalue = $count;
  }

  $date_format = "DDMONYYYY-HH24";

  $statement  = "
    select
      to_char(ts, '$date_format'),
      count(*)
    from
      dbamon.ticket_governor
    group by
      to_char(ts, '$date_format')
    order by 
      to_char(ts, '$date_format')
    ";

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("Done selecting data...");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $ts    = $Data[0];
    $count = $Data[1];

    $tsout = "${ts}:00";
    $sasdata .= "$tsout $count\n";

  }

  $tmpsaspgm = "/tmp/${P}_${$}_saspgm.sas";
  #$tmpsaslst = "/tmp/${P}_${$}_saspgm.lst";
  #$tmpsaslog = "/tmp/${P}_${$}_saspgm.log";
  $tmpsasgif = "/tmp/${P}_${$}_saspgm.gif";
  $wwwsasgif = "/opt/web/dba/tmp/${P}_${$}_saspgm.gif";

  $saspgm = "
      data w1;
      format
        ts datetime7.
        ; 
      input 
        ts datetime15. 
        count 9.
        ;
      cards;
$sasdata
    ;

    proc sort;
      by ts;

    /*
    option pagesize=60 linesize=80 ;
    proc print;
    run;
    */

  goptions
    device=imggif
    gaccess=sasgastd
    gsfname=grafout
    gsfmode=replace
    ;
  run;

  %let font     = simplex;
  %let color    = blue;
  filename grafout '$tmpsasgif';
  run;

proc gplot;

  symbol i=join;

  symbol1 w=1 c=green  i=sm50 v=none;
  symbol2 w=1 c=red    i=join v=none;
  symbol3 w=1 c=yellow i=join v=none;
  symbol4 w=1 c=blue  i=join v=none;
  symbol5 w=1 c=purple i=join v=none;
  symbol6 w=1 c=cyan   i=join v=none;
  symbol7 w=1 c=red    i=join v=none;
  symbol8 w=1 c=white   i=join v=none;
  symbol9 w=1 c=green   i=join v=plus;
  symbol10 w=1 c=red    i=join v=plus;
  symbol11 w=1 c=yellow i=join v=plus;
  symbol12 w=1 c=blue   i=join v=plus;
  symbol13 w=1 c=purple i=join v=plus;
  symbol14 w=1 c=cyan   i=join v=plus;
  symbol15 w=1 c=red    i=join v=plus;
  symbol16 w=1 c=white  i=join v=plus;

  axis1 label = (c=black  h=1.4 f=&font)
        value = (f=&font)
        ;

  axis2 label = (c=black  h=1.4 a=90 r=0 f=&font)
        value = (f=&font)
        ;

  title1 f=&font c=darkblue h=2.5 'DBAmon Ticket Rate - By Date/Hour';
  title2 f=&font c=darkblue h=1.7 'Most Recent Value: $mrvalue Tickets/Hour';
  footnote1 f=&font c=red h=1.7 'Ticket Governor is Invoked at 120 Tickets/Hour';

  label count  = 'Sample Ticket Rate (Tickets/Hour)';
  label ts     = 'Timestamp';
  
  plot
    count*ts = 4
    count*ts = 1
       /
         overlay
         grid
         vzero
         haxis = axis1
         vaxis = axis2
         vminor=1
         hminor=1
         cframe = skyblue
        vref=100
       cvref=red
       lvref=2
         ;
    ";

  ##&msg("saspgm=<pre>$saspgm</pre>");

  open(SASPGM, ">$tmpsaspgm") || &error("Cannot open output $tmpsaspgm - $!");
  print SASPGM "$saspgm";
  close(SASPGM);

  &msg("Invoking SAS");

  $rc = system("cd /tmp;/opt/sas1/sas -work /tmp $tmpsaspgm 2>&1");

  &msg("Back from SAS - rc=$rc");

  ##print "<pre><font size=2></center>\f";
  ##system("cat $tmpsaslst | sed 's/</{/g'");
  ##system("cat $tmpsaslog | sed 's/</{/g'");
  ##print "</pre>";

  system("cp $tmpsasgif $wwwsasgif");
  print "<hr><img src='/dba/tmp/${P}_${$}_saspgm.gif'><hr>";
  &msg("Graph file: /dba/tmp/${P}_${$}_saspgm.gif");
}

#-----------------------------------------------------------------------------
sub report_instsum
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "
    create table z1 as
    select
      distinct
	substr(zdate,1,7) wdate,
	upper(dbms) dbms,
	instance
    from
      dbamon.history
    where 
      dbamonmode = '$dbamonmode'";
  $rc = $dbh->do("$statement") || &error('Failed_on_DB_do_delete');

  $statement  = "select
      wdate,
      dbms,
      count(*)
    from
      z1
    group by
      wdate,
      dbms ";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<center><table border=0> \n";
  print "<tr bgcolor=slate><th>Month<th>DBMS/Appl.<th>Instance Count\n";
  while (@Data = $sth->fetchrow_array)
  {
    $wdate    = $Data[0];
    $dbms     = $Data[1];
    $count    = $Data[2];
    

    if ($wdate ne $last_wdate && $flag == 1)
    {
      print "<tr bgcolor=skyblue><td colspan=2><b>Total For Month:<td align=right><b>$running_total \n";
      print "<tr ><td colspan=3><hr> \n";
      $running_total = 0;
    }
    else
    {
    }

    $flag = 1;

    print "<tr ><td>$wdate <td>$dbms <td align=right><b>$count \n";
    $last_wdate = $wdate;
    $running_total += $count;
  }

      print "<tr bgcolor=skyblue><td colspan=2><b>Total For Month:<td align=right><b>$running_total \n";
      print "<tr ><td colspan=3><hr> \n";
  
  print "</table></center> \n";
}

#-----------------------------------------------------------------------------
sub checkDT
#-----------------------------------------------------------------------------
{
  my $in_key = $_[0];

  $dtprevent = ""; 
  $dtdesc    = ""; 

  $dtfile = "/opt/dbamon/adm/downtime/dt_${in_key}.txt"; 
  return if ! -e "$dtfile";
  open(DT,"$dtfile") || &error("Cannot open $dtfile = $!"); 
  while(<DT>)
  {
    next if /^#/;
    if (/^Prevent: /)
    {
      $dtprevent = substr($_,11); 
    }
    if (/^Desc: /)
    {
      $dtdesc = substr($_,11); 
    }
  }
  close(DT);
}

#-----------------------------------------------------------------------------
sub report_uptime1
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $statement  = "select
      to_char(tot_date,\'YYYY/MM/DD\') ,
      tot_downtime,
      tot_pct
    from
      dbamon.uptime_summary
    where 
      instance = '$arg1'
    order by
      1 ";
  ##print "statement=$statement \n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $count = 0;
  print "<center><table border=0> \n";
  print "<tr bgcolor=slate><th>Date<th>Instance<br>Downtime<br> (Minutes)<th>Daily<br>Uptime<br> %<th>Histogram\n";
  while (@Data = $sth->fetchrow_array)
  {
    $date     = $Data[0];
    $downtime = int($Data[1]/60);
    $pct      = sprintf("%5.1f",$Data[2]);
    
    $hist = "*" x int($pct/3);
    #$hist = "&gt;" x int($pct/3);
    #$hist = "&curren;" x int($pct/3);
    if    ($pct >= 99) { $c = "green"; }
    elsif ($pct >= 95) { $c = "yellow"; }
    else               { $c = "red"; }

    print "<tr ><td><b>$date <td align=right>$downtime <td align=right><b>$pct <td><font color=$c><b>$hist</b></font>  \n";
    $count++; 
    $t_pct += $pct;
    $t_downtime += $downtime;
  }

  if ($count > 0)
  {
    $m_pct = sprintf("%5.1f",$t_pct / $count);
  }
  $hist = "*" x int($m_pct/3);
  print "<tr bgcolor=slate><th>Total:<td align=right>$t_downtime <td align=right><b>$m_pct <td bgcolor=white><font color=$c><b>$hist</b></font>  \n";

  print "</table> \n";
  print "<p><b>Histogram Color Legend:</b>\n";
  print "<br><font color=green><b>Pct >= 99%</b></font>\n";
  print "<br><font color=yellow><b>Pct >= 95%</b></font>\n";
  print "<br><font color=red><b>Pct < 95%</b></font>\n";
  print "</center> \n";
  if ($count == 0)
  {
    print "<b>Note:</b> No rows retrieved. There is only uptime data for Oracle8 and higher\n";
  }
}

#-----------------------------------------------------------------------------
sub report_uptime5
#-----------------------------------------------------------------------------
{
  &msg("Creating Report uptime5"); 

  # SQL> desc dbamon.uptime_summary
  #  Name                                      Null?    Type
  #  ----------------------------------------- -------- ----------------------------
  #  INSTANCE                                  NOT NULL CHAR(32)
  #  TOT_DATE                                  NOT NULL DATE
  #  TOT_TIME                                  NOT NULL NUMBER(38)
  #  TOT_DOWNTIME                              NOT NULL NUMBER(38)
  #  TOT_PCT                                   NOT NULL NUMBER(6,2)
  #  TS                                                 DATE
  #  US_SBY_FLAG                                        CHAR(1)
  #  US_KEY                                             NUMBER(38)

  $statement  = "select
      us_key,
      instance,
      to_char(tot_date,'YYYY/MM/DD'),
      tot_time,
      tot_downtime,
      tot_pct,
      us_sby_flag,
      to_char(ts,'YYYY/MM/DD-HH24:MI:SS')
    from
      dbamon.uptime_summary
    where 
      instance = '$arg1'
    order by
      3 desc";
  ##print "statement=$statement \n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("Report Complete"); 

  $count = 0;
  print "<zcenter><table border=0> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>Date
    <th><font size=2>Downtime<br> Row<br> Key
    <th><font size=2>Total Time <br>(Secs/Mins)
    <th><font size=2>Down Time <br>(Secs/Mins)
    <th><font size=2>Uptime %
    <th><font size=2>Sby
    <th><font size=2>Row Inserted
    <th><font size=2>Instance
  \n";
  while (@Data = $sth->fetchrow_array)
  {
    $key          = shift @Data;
    $inst         = shift @Data;
    $tot_date     = shift @Data;
    $tot_time     = shift @Data;
    $tot_downtime = shift @Data;
    $tot_pct      = shift @Data;
    $sby          = shift @Data;
    $ts           = shift @Data;

    if ($last_strc && $strc ne $last_strc)
    {
      $attr = "bgcolor=lime"; 
    }
    else
    {
      $attr = ""; 
    }

    $bg = &bg;
    $bg = "bgcolor=pink" if $tot_pct != 100; 

    $tot_time_mins = int($tot_time / 60);
    $tot_downtime_mins = int($tot_downtime / 60);


    if ($tot_pct < 100)
    {
      $href = "<a href='/cgi-bin/dbamon_downtime_edit.pl?$key?go'><b> $key </b></a>"; 
    }
    else
    {
      $href = "$key"; 
    }

    &checkDT($key); 

    if ($dtdesc || $dtprevent)
    {
      $dtdata = "
        <tr bgcolor=pink><td><td>$fs DowntimeDescription: <td colspan=9>$fs<b>$dtdesc</b>
        <tr bgcolor=pink><td><td>$fs DowntimePrevented:   <td colspan=9>$fs<b>$dtprevent</b>
      "; 
    }
    else
    {
      $dtdata = ""; 
    }

    print "<tr $bg $attr>
      <td><font size=2><b>$tot_date</b>
      <td align=right><font size=2>$href 
      <td><font size=2>$tot_time / $tot_time_mins
      <td><font size=2>$tot_downtime / $tot_downtime_mins
      <td><font size=2>$tot_pct
      <td><font size=2>$sby
      <td><font size=2>$ts
      <td><font size=2>$inst 
      $dtdata
    ";
    $count++; 


    $last_strc = $strc; 
  }

  print "</table> \n";
}

#-----------------------------------------------------------------------------
sub report_uptime4
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  &msg("Creating Report");

  $statement  = "select
      str_c,
      str_n,
      end_c,
      end_n,
      instance,
      ud_fqhostname,
      ud_processed
    from
      dbamon.uptime_detail
    where 
      instance = '$arg1'
    order by
      4 desc";
  ##&msg("DEBUG - sql=$statement");

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("Report complete");

  $count = 0;
  print "<zcenter><table border=0> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>DB Start Timestamp - Text / Numeric
    <th><font size=2>Sample Timestamp - Text / Numeric
    <th><font size=2>Instance
    <th><font size=2>FQHost
    <th><font size=2>Processed
  \n";
  while (@Data = $sth->fetchrow_array)
  {
    $strc     = shift @Data;
    $strn     = shift @Data;
    $endc     = shift @Data;
    $endn     = shift @Data;
    $o_inst   = shift @Data;
    $o_fq     = shift @Data;
    $o_proc   = shift @Data;

    $bg = &bg;
    if ($last_strc && $strc ne $last_strc)
    {
      $bg = "bgcolor=pink"; 
    }

    print "<tr $bg>
      <td><font size=2>$strc / $strn
      <td><font size=2>$endc / $endn
      <td><font size=2>$o_inst
      <td><font size=2>$o_fq
      <td><font size=2>$o_proc
    ";
    $count++; 

    $last_strc = $strc; 
  }

  print "</table> \n";
  &msg("Selected $count rows"); 
}

#-----------------------------------------------------------------------------
sub report_uptime3
#-----------------------------------------------------------------------------
{
  &msg("Checking DBAmon task status");
  return if &checkTasks == 1; 

  $exclude_id3_list = "'Oracle-AMS','LSCA-SAP','HP-Avago-Ifmx'"; 

  $sleeptime = 20;
  $sleepcnt  = 1;  

  &msg("Checking DBAmon Repository for consistency");
  while  ( &checkDB == 1) 
  {
    sleep $sleeptime;
    $sleepcnt++; 
  } 

  $statement  = "select
      to_char(tot_date,\'YYYY/MM\'),
      decode(sd.id8,
        'Gold',   '1-Gold',
        'Silver', '2-Silver',
        'Bronze', '3-Bronze',
        'Copper', '4-Copper',
        sd.id8
        ),
      count(*), 
      avg(tot_downtime),
      avg(tot_pct)
    from
      dbamon.uptime_summary us,
      dbamon.summary_detail sd
    where 
      sd.dbamonmode like 'prod%'
      and us.instance = sd.title
      and us_sby_flag not in ('Y','R')
      and (id3 is null or id3 not in ($exclude_id3_list))
    group by
      to_char(tot_date,\'YYYY/MM\'),
      sd.id8
    order by
      1 desc, 2";
  ##print "statement=$statement \n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $count = 0;
  print "<center><table border=0> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>Month
    <th><font size=2>Delivery Level
    <th><font size=2>SLA Uptime % 
    <th colspan=2><font size=2>Avg Uptime %
  \n";
  while (@Data = $sth->fetchrow_array)
  {
    $month          = shift @Data;
    $delivery_level = shift @Data;
    $count          = shift @Data;
    $avg_downtime   = shift @Data;
    $avg_pct        = shift @Data;

    next if $delivery_level eq "?";

    $avg_downtime = sprintf("%.2f",$avg_downtime);
    $avg_pct = sprintf("%.2f",$avg_pct);
    
    if    ($delivery_level eq "1-Gold")   { $sla = 99.5; }
    elsif ($delivery_level eq "2-Silver") { $sla = 99; }
    elsif ($delivery_level eq "3-Bronze") { $sla = 98; }
    else { $sla = "N/A"; }

    if ($sla eq "N/A") { $sla_out = $sla; }
    else               { $sla_out = ">= ${sla}%"; }

    if ($sla eq "N/A") { $color = "blue"; }
    elsif ($avg_pct >= $sla) { $color = "green"; }
    else { $color = "red"; }

    $zwidth = $avg_pct*2;

    if ($last_month && $month ne $last_month)
    {
      $month_tot_avg = sprintf("%.2f",($month_avg / $month_cnt)) if $month_cnt > 0;
      $month_cnt = 0;
      $month_avg = 0;
      print "<tr bgcolor=slate>
        <td colspan=3><b><font size=2>Month $last_month Average: 
        <td colspan=1 align=right><b><font size=2>${month_tot_avg}%
        \n";
    }

    $bg = &bg;
    print "<tr $bg>
      <td><b><font size=2>$month 
      <td><b><font size=2>$delivery_level 
      <td align=right><font size=2><b>$sla_out
      <td align=right><font size=2><b>${avg_pct}%
      <td><img src='/dbamon/img/$color.gif' height=15 width=$zwidth>
    \n";

    $last_month = $month;
    $month_cnt++; 
    $month_avg += $avg_pct; 

    $count++; 
    $t_pct += $pct;
    $t_downtime += $downtime;
  }

  if ($count > 0)
  {
    $m_pct = sprintf("%5.1f",$t_pct / $count);
  }
  $hist = "*" x int($m_pct/3);
  print "<tr bgcolor=slate><th>Total:<td align=right>$t_downtime <td align=right><b>$m_pct <td bgcolor=white><font color=$c><b>$hist</b></font>  \n";

  print "</table> \n";
}

#-----------------------------------------------------------------------------
sub report_uptime2
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $statement  = "select
      to_char(tot_date,\'MM,DD,YYYY') ,
      tot_downtime,
      tot_pct
    from
      dbamon.uptime_summary
    where 
      instance = '$arg1'
      and tot_date >= sysdate - 30
    order by
      1 ";
  ##print "statement=$statement \n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  print '<script language="JavaScript1.2" SRC="/dbamon/javagraph/my_graph.js"></script>';

  $count = 0;

  #print "<center><table border=0> \n";
  #print "<tr bgcolor=slate><th>Date<th>Instance<br>Downtime<br> (Minutes)<th>Daily<br>Uptime<br> %<th>Histogram\n";

  while (@Data = $sth->fetchrow_array)
  {
    $date     = $Data[0];
    $downtime = int($Data[1]/60);
    $pct      = sprintf("%5.1f",$Data[2]);
    
    $sdate = $date if $sdate eq "";

    $hist = "*" x int($pct/3);
    #$hist = "&gt;" x int($pct/3);
    #$hist = "&curren;" x int($pct/3);
    if    ($pct >= 99) { $c = "green"; }
    elsif ($pct >= 95) { $c = "yellow"; }
    else               { $c = "red"; }

    #print "<tr ><td><b>$date <td align=right>$downtime <td align=right><b>$pct <td><font color=$c><b>$hist</b></font>  \n";

    $pcts .= "$pct,";
    
    $count++; 
    $t_pct += $pct;
    $t_downtime += $downtime;
  }
  chop $pcts;
  ##print "pcts=$pcts\n<hr>";
  print "
<script language='JavaScript1.2'>
var g = new Graph(725,250);
g.path = 'http://$hostname/dbamon/javagraph/';
g.xLabel = 'Date';
g.yLabel = '%';
g.scale = 25;
g.skip = 10;
g.title = 'Uptime % By Date - $arg1';
g.setDate($sdate);
g.addRow($pcts);
g.build();
</script><hr>
  ";

  if ($count > 0)
  {
    $m_pct = sprintf("%5.1f",$t_pct / $count);
  }
  $hist = "*" x int($m_pct/3);
  print "<b>Date Range: </b> $sdate <b> Through: </b> $date ($count Days)\n";
  print "<br><b>Total Downtime Minutes During Last 30 Days:</b> $t_downtime \n";
  print "<br><b>Total Downtime Percentage During Last 30 Days:</b> $m_pct \n";

  if ($count == 0)
  {
    print "<b>Note:</b> No rows retrieved. There is only uptime data for Oracle8 and higher\n";
  }
}

#-----------------------------------------------------------------------------
sub report_EVHistory
#-----------------------------------------------------------------------------
{
  $maxrows = $arg1 if $arg1 > 0;
  &msg("report_EVHistory Starting - maxrows=$maxrows"); 
  $s_time = time;

  if ($dbamon_repos eq "O") 
  {
    $sql  = "
      select 
	to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
	instance, 
	system, 
	sev, 
	text,
	paged,
	ticket
      from 
	dbamon.events 
      where 
	ts >= (sysdate - 1)
	and sev = 'C'
      order by ts desc
    ";
  }
  else
  {
    $sql  = "
      select 
	--to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
	dbamon.dateconvert_19(ts), 
	instance, 
	system, 
	sev, 
	text,
	paged,
	ticket
      from 
	dbamon.events 
      where 
	--ts >= (sysdate - 1)
        datediff(day,ts,getdate()) <= 30 
	--and sev = 'C'
      order by ts desc
    ";
  }

  $sth = $dbh->prepare($sql) || &error('Failed_2230');
  $sth->execute || &error('Execute_2231');

  $e_time = time;
  $elapsed = $e_time - $s_time;
  &msg("Query elapsed time: $elapsed second(s) - Building dynamic html"); 

  ##print "<p><table border=1 >\n";
  print "<p><table border=0 bgcolor=beige >\n";
  print "<tr bgcolor=cadetblue>
    <th><span $style_normal>#
    <th><span $style_normal>Event<br>Timestamp
    <th><span $style_normal>Target<br>Server
    <th><span $style_normal>Target<br>Instance
    <th><span $style_normal>Ticket?
    <th><span $style_normal>Paged?
    <th><span $style_normal>Event<br>Severity
    <th><span $style_normal>DBAmon<br>MsgId 
    <th><span $style_normal>Event Text
  ";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = $Data[0];
    $in    = $Data[1];
    $sy    = $Data[2];
    $sev   = $Data[3];
    $text  = $Data[4];
    $paged = $Data[5];
    $ticket= $Data[6];

    if ($paged ne "Y" && $paged ne "N") { $paged = "N"; }
    $ticket = "N" if $ticket eq ""; 

    $selectcount++;
     
    if    ($sev eq "C") { $color = "pink";   $fcolor = "black"}
    elsif ($sev eq "W") { $color = "yellow"; $fcolor = "black"}
    elsif ($sev eq "I") { $color = "cyan";   $fcolor = "black" }
    elsif ($sev eq "U") { $color = "lime";   $fcolor = "black"}
    elsif ($sev eq "P") { $color = "lightblue";   $fcolor = "black"}
    else { $color = "white"; }

    if ($company eq "crud" && length($ticket) > 1) 
    {
      $ticket_url = "<b><a href='blt_lookup.pl?$ticket'>$ticket</a>";
    }
    else
    {
      $ticket_url = $ticket;
    }

    $msgid = (split(/ /,$text)) [0];
    $msgid_short = substr($msgid,0,6);
    $msgid_url = "<b><a href='http://dbamon.com/errors/index.shtml#$msgid_short'>$msgid_short</a></b>";
    $text_fixed = substr($text,7); 

    $bg = &bg;
    print "<tr $bg>
      <td><span $style_normal>$selectcount.
      <td nowrap><span $style_normal><b>$ts </b>
      <td><span $style_normal>$sy
      <td nowrap><span $style_normal><b>$in</b>
      <td nowrap><span $style_normal>$ticket
      <td nowrap><span $style_normal>$paged
      <td bgcolor=$color><span $style_normal>$sev
      <td bgcolor=$color nowrap><span $style_normal>$msgid_url
      <td bgcolor=$color nowrap><span $style_normal><b>$text</b>
    ";

    if ($selectcount >= $maxrows)
    {
      print "
      <tr bgcolor=pink><td colspan=9><span $style_normal><b>Maxrows=$maxrows Reached - Terminating </b>
      </table>
      "; 
      &msg("Maxrows=$maxrows Reached"); 
      last;
    }
  }
  print "</table>";

  if ($selectcount == 0) 
  { 
    &msg("No event history data found");
  }
  
  &msg("report_EVHistory Done - Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub report_IDEvents
#-----------------------------------------------------------------------------
{
  $idfield = $arg1; 
  $idval   = $arg2;
  $maxrows = 2000; 
  &error("Usage: IDEvents {IDField} {IDVal}") if $idfield eq "" || $idval eq ""; 


  &msg("report_IDEvents Starting - idfield=$idfield idval=$idval - maxrows=$maxrows"); 
  $s_time = time;

  #$sql  = "select
  #  dbamon.dateconvert_19(ev.ts),
  #  instance,
  #  ev.system,
  #  sev,
  #  text,
  #  paged,
  #  ticket,
  #  datediff(hh,ev.ts,getdate()) 
  #from
  #  dbamon.events ev,
  #  dbamon.summary_detail sd
  #WHERE
  #  ev.instance = sd.title
  #  AND sd.$idfield = '$idval'
  #  AND sd.dbamonmode like '${dbamonmode}%' 
  #  --AND datediff(day,ev.ts,getdate()) <= 30
  #order by ev.ts desc
  #";

  $sql = "SELECT distinct dbamon.dateconvert_19(ev.ts) ,
	    instance ,
	    ev.system ,
	    sev ,
	    text ,
	    paged ,
	    ticket ,
	    DATEDIFF(hh, ev.ts, GETDATE())
    FROM    dbamon.events ev ,
	    dbamon.summary_detail sd
    WHERE   ev.instance = sd.title
	    AND sd.$idfield = '$idval'
	    AND ev.source LIKE 'DBAmon%P'
	    AND sd.dbamonmode like 'prod%'
	    AND DATEDIFF(day, ev.ts, GETDATE()) <= 90
            AND ev.ticket != 'SD'
    ORDER BY 1 DESC
  "; 

  &msg("Dynamic SQL: $sql"); 
  $sth = $dbh->prepare($sql) || &error('Failed_2230');
  $sth->execute || &error('Execute_2231');

  $e_time = time;
  $elapsed = $e_time - $s_time;
  &msg("Query elapsed time: $elapsed second(s) - Building dynamic html"); 

  ##print "<p><table border=1 >\n";
  print "<h4>DBAmon Mode=PROD Events For All Instances with $idfield=$idval - Last 90 Days (Suppressed Duplicates Excluded)</h4>\n"; 
  print "<p><table border=0 bgcolor=beige >\n";
  print "<tr bgcolor=cadetblue>
    <th><span $style_normal>#
    <th><span $style_normal>Event<br>Timestamp
    <th><span $style_normal>Days<br>Ago
    <th><span $style_normal>Target<br>Server
    <th><span $style_normal>Target<br>Instance
    <th><span $style_normal>Ticket<br>?
    <th><span $style_normal>Paged<br>?
    <th><span $style_normal>Event<br>Sev.
    <th><span $style_normal>DBAmon<br>MsgId 
    <th><span $style_normal>Event Text
  ";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = $Data[0];
    $in    = $Data[1];
    $sy    = $Data[2];
    $sev   = $Data[3];
    $text  = $Data[4];
    $paged = $Data[5];
    $ticket= $Data[6];
    $hoursago= $Data[7];

    if ($paged ne "Y" && $paged ne "N") { $paged = "N"; }
    $ticket = "N" if $ticket eq ""; 

    $selectcount++;
     
    if    ($sev eq "C") { $color = "pink";   $fcolor = "black"}
    elsif ($sev eq "W") { $color = "yellow"; $fcolor = "black"}
    elsif ($sev eq "I") { $color = "cyan";   $fcolor = "black" }
    elsif ($sev eq "U") { $color = "lime";   $fcolor = "black"}
    elsif ($sev eq "P") { $color = "lightblue";   $fcolor = "black"}
    elsif ($sev eq "S") { $color = "violet";   $fcolor = "black"}
    else { $color = "white"; }

    if ($company eq "crud" && length($ticket) > 1) 
    {
      $ticket_url = "<b><a href='blt_lookup.pl?$ticket'>$ticket</a>";
    }
    else
    {
      $ticket_url = $ticket;
    }

    $msgid = (split(/ /,$text)) [0];
    $msgid_short = substr($msgid,0,6);
    $msgid_url = "<b><a href='http://dbamon.com/errors/index.shtml#$msgid_short'>$msgid_short</a>";
    $text_fixed = substr($text,7); 
    $daysago = sprintf("%.2f",$hoursago/24);

    $datepart = substr($ts,0,10); 

    if ($ticket eq "SD") 
    {
      $ticket_text = "(Suppressed-Dup)"; 
      $color = "lightgray"; 
    }
    elsif ($ticket eq "SI") 
    {
      $ticket_text = "(Suppressed-Inh)"; 
      $color = "lightgray"; 
    }
    else
    {
      $ticket_text = ""; 
    }

    if ($datepart ne $last_datepart)
    {
      print "<tr bgcolor=grey> <td colspan=10><span $style_normal><b> &nbsp; Rows for $datepart: </b>  \n"; 
    }

    $bg = &bg;
    print "<tr $bg>
      <td><span $style_normal>$selectcount.
      <td nowrap><span $style_normal><b>$ts</b>
      <td nowrap><span $style_normal><b>$daysago</b>
      <td><span $style_normal>$sy
      <td nowrap><span $style_normal><b>$in</b>
      <td nowrap><span $style_normal>$ticket $ticket_text
      <td nowrap><span $style_normal>$paged
      <td bgcolor=$color><span $style_normal>$sev
      <td bgcolor=$color nowrap><span $style_normal> $msgid_url
      <td bgcolor=$color nowrap><span $style_normal><b>$text</b>
    ";

    if ($selectcount >= $maxrows)
    {
      print "
      <tr bgcolor=pink><td colspan=9><span $style_normal><b>Maxrows=$maxrows Reached - Terminating </b>
      </table>
      "; 
      &msg("Maxrows=$maxrows Reached"); 
      last;
    }
    $last_datepart = $datepart; 
  }
  print "</table>";

  if ($selectcount == 0) 
  { 
    &msg("No event history data found - This may be because DBAmon is in the process of restarting - Try again later");
  }
  
  &msg("report_IDEvents Done - Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub report_id1dbms
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  # Get totals by ID1 value

  $statement  = "
    select
      misc2,
      count(*) 
    from 
      dbamon.instances
    where
      dbamonmode like 'prod%'
    group by
      misc2 ";

  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);

  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $id1      = $Data[0];
    $count    = $Data[1];

    $id1 = "[Null]" if $id1 eq "";
    $id1total{$id1} = $count;
    ##print "$id1=$id1total{$id1} \n";
  }

  $statement  = "
    select
      misc2,
      dbms,
      count(*) 
    from 
      dbamon.instances
    where
      dbamonmode like 'prod%'
    group by
      misc2,
      dbms
    ";

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;

  print "<center><table border=0> \n";
  print "<tr bgcolor=slate><th>ID1 Value<th>DBMS/Appl.<th>Instance Count<th>% of ID1<br>Total<br>Instances\n";

  while (@Data = $sth->fetchrow_array)
  {
    $id1      = $Data[0];
    $dbms     = $Data[1];
    $count    = $Data[2];

    $selectcount++;

    $id1 = "[Null]" if $id1 eq "";

    if ($id1 ne $last_id1 && $flag == 1)
    {
      print "<tr bgcolor=skyblue><td colspan=2><b>Instance Total For ID1=$last_id1:<td align=right><b>$running_total \n";
      print "<tr ><td colspan=3><hr> \n";
      $running_total = 0;
    }
    else
    {
    }

    $flag = 1;

    $pct = $count / $id1total{$id1};
    $pct = sprintf("%5.1f",$pct*100);

    print "<tr ><td>$id1 <td>$dbms <td align=right><b>$count <td align=right>${pct}% \n";
    $last_id1 = $id1;
    $running_total += $count;
    $grand_total += $count;
  }

  print "<tr bgcolor=skyblue><td colspan=2><b>Instance Total For ID1=$id1:<td align=right><b>$running_total \n";
  print "<tr ><td colspan=3><hr> \n";
  
  print "<tr bgcolor=skyblue><td colspan=2><b>All ID1 Values Total:<td align=right><b>$grand_total \n";
  print "<tr ><td colspan=3><hr> \n";

  print "</table></center> \n";
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  #local($Signal) = @_;
  exit(0);
}

#-----------------------------------------------------------------------------
sub error
#-----------------------------------------------------------------------------
{
  my $zerr = $_[0]; 
  &msg("Fatal Error: $zerr"); 
  exit 1; 
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "</table><br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#------------------------------------------------------------------------------
sub CheckForEvilness
#------------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
sub report_swver
#-----------------------------------------------------------------------------
{
  &msg("report_swver - Starting"); 

  #---- Vars
  $csv_file_short = "${P}_SWVer_${$}.csv";
  $csv_dir        = "/opt/dbamon/dat/dyn";
  $csv_file       = "$csv_dir/$csv_file_short";
  $csvout         = ""; 

  #---- Process ARG1
  if    ($arg1 eq "PROD") 
  { 
    $where2 = " AND Misc1 = 'PROD' "; 
  } 
  elsif ($arg1 eq "NONPROD") 
  {  
    $where2 = " AND Misc1 != 'PROD' "; 
  } 
  elsif ($arg1 eq "ALL") 
  {  
    $where2 = ""; 
  } 
  else                    { &error("Arg1 must be ALL, PROD or NONPROD"); } 

  #---- Read from current events table
  $sql  = "SELECT DISTINCT title, [text], ins.Misc1, ins.Misc6, ins.Misc15
  FROM [DBAmon].[dbamon].[event_detail] ed,
       DBAmon.DBAmon.Instances ins
  WHERE ed.system = INS.fqhostname
    AND ed.dbamonmode like 'prod%'
    AND msgid = 'DBA652' $where2 ORDER BY 1 ;
   ";
  &msg("Running sql=$sql"); 
  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $swv_instance_title = uc shift(@Data);
    $swv_event_text     = shift(@Data);
    $swv_misc1          = uc shift(@Data);
    $swv_misc6          = uc shift(@Data);
    $swv_misc15         = uc shift(@Data);
   
    $rpt_hostname       = (split(/_/,$swv_instance_title))[0];
    $rpt_mssql_instance = (split(/_/,$swv_instance_title))[2];
   
    $zpatchlevel        = (split(/\(/,$swv_event_text))[2];

    ##&msg("DEBUG swv_event_text=$swv_event_text zpatchlevel=$zpatchlevel"); 

    $rpt_patchlevel = (split(/\//,$zpatchlevel))[0];
    $rpt_kbnum      = (split(/\//,$zpatchlevel))[1];

    $rpt_kbnum      = (split(/\)/,$rpt_kbnum))[0];

    ##&msg(" &nbsp;  &nbsp; $selectcount. Found rpt_hostname=$rpt_hostname rpt_mssql_instance=$rpt_mssql_instance - rpt_kbnum=($rpt_kbnum) rpt_patchlevel=($rpt_patchlevel)"); 

    $csvout .= "$rpt_hostname, $rpt_kbnum, $rpt_patchlevel, $swv_misc1, $swv_misc15, $swv_misc6, For MSSQL Instance: $rpt_mssql_instance\n"; 

    $html_table_body .= "<tr bgcolor=snow>
      <td align=right>$ss_med $selectcount. 
      <td>$ss_med <b>$rpt_hostname</b>
      <td>$ss_med <b>$rpt_kbnum</b>
      <td>$ss_med $rpt_patchlevel
      <td>$ss_med $swv_misc1
      <td>$ss_med $swv_misc15
      <td>$ss_med $swv_misc6
      <td>$ss_med $rpt_mssql_instance
  "; 
  }

  if ($selectcount == 0) 
  {
    &msg("No data found, which probably means that DBAmon has been restarted and has not yet completed Iteration #1 - Please try again later"); 
    return; 
  }

  &msg("Creating CSV report ($selectcount rows found) ..."); 
  open (CSVOUT, ">$csv_file") || &error("Cannot open output csv_file=$csv_file - $!"); 
  print CSVOUT "Server, KBNum_Needed, MSSQL_Patch_Level_Needed, Environment_ID1, Application_ID15, MSSQL_Version_ID6, Notes\n"; 
  print CSVOUT $csvout; 
  close(CSVOUT); 

  &msg("CSV Report Done - Click for CSV File: <a href='/dbamon/dyn/$csv_file_short'>$csv_file_short</a> (this should open in Excel)"); 

  print "<p>\n"; 

  ##&msg("Report:"); 
  print "<p><table bgcolor=wheat>
<tr bgcolor=lightsteelblue>
  <th>$ss_med #
  <th>$ss_med Server
  <th>$ss_med KBNum Needed
  <th>$ss_med MSSQL Patch Level Needed
  <th>$ss_med Environment_ID1
  <th>$ss_med Application_ID15
  <th>$ss_med MSSQL_Version_ID6
  <th>$ss_med Notes
$html_table_body
</table>
  "; 

  &msg("report_swver - Done - selectcount=$selectcount"); 
}

#-----------------------------------------------------------------------------
sub cleanDir
#-----------------------------------------------------------------------------
{
  $zdir    = $_[0]; 
  $zsearch = $_[1]; 
  $zdays   = 7; 
  &msg("cleanDir - Starting - zdir=$zdir zsearch=$zsearch - zdays=$zdays"); 

  $debug_cd = 1; 

  opendir(CLEANDIR, "$zdir") || &error("Cannot opendir $zdir - $!");
  @dirfiles = sort readdir CLEANDIR;
  closedir(CLEANDIR);
  
  foreach $zfile (@dirfiles)
  {
    next unless $zfile =~ /$zsearch/; 
    &msg("DEBUG - Found zdir=$zdir zfile=$zfile ($zdir/$zfile)") if $debug_cd; 

    $z_mtime = ( stat "$zdir/$zfile" ) [9];

    $z_fileage_days = sprintf("%.2f", (time - $z_mtime) ); 
    $z_time = time; 
    &msg("DEBUG -   z_time=$z_time z_mtime=$z_mtime - z_fileage_days=$z_fileage_days") if $debug_cd; 

  }
  
  &msg("cleanDir - Done"); 
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

chdir("/opt/dbamon/htm/javagraph/");
system("env > /tmp/env");

$SaveFile = "/tmp/dbamon_rpt.log";
unlink($SaveFile);
chop($CurrentDate = `date`);

&get_request;

chop($hostname = `hostname`);

@words = split(/,/,$ARGV[0]);
$dbamonmode = $words[0];
$report     = $words[1];
$arg1       = $words[2];
$arg2       = $words[3];

$title = "Count of Instances By DBMS/Appl. And Month" if $report eq "instsum";
$title = "Oracle/UX DB's By DBID" if $report eq "oradbs";
$title = "Count of Instances By ID1 and DBMS" if $report eq "id1dbms";
$title = "Unplanned Downtime By Date" if $report eq "uptime1";
$title = "Recently Modified Notepad Entries" if $report eq "text";
$title = "Server and CPU Count by DBMS" if $report eq "cpucount";
$title = "Instance Billing Report" if $report eq "bill";
$title = "SLA Compliance" if $report eq "SLA";
$title = "DB Uptime SLA Compliance - Oracle/UX Only" if $report eq "uptime3";
$title = "DB Uptime Detail" if $report eq "uptime4";
$title = "DB Uptime Summary" if $report eq "uptime5";
$title = "Global Instance Health" if $report eq "health";
$title = "Global Event History" if $report eq "EVHistory";
$title = "Events for Instances with $arg1=$arg2" if $report eq "IDEvents";

open(LOG, ">>$SaveFile" );
print LOG "$P $CurrentDate : \n";

$zreport = ucfirst $report;
&header("DBAmon Report: ($zreport) $title");
&msg("Starting - dbamonmode=$dbamonmode report=$report arg1=($arg1) arg2=($arg2)"); 

#---- Connect to DB
&connectDB;

if    ($report eq "instsum")    { &report_instsum(); }
elsif ($report eq "swver")      { &report_swver(); }
elsif ($report eq "oradbs")     { &report_oradbs(); }
elsif ($report eq "oraver7")    { &report_oraver7(); }
elsif ($report eq "oraservers") { &report_oraservers(); }
elsif ($report eq "id1dbms")    { &report_id1dbms(); }
elsif ($report eq "uptime1")    { &report_uptime1(); }
elsif ($report eq "uptime2")    { &report_uptime2(); }
elsif ($report eq "uptime3")    { &report_uptime3(); }
elsif ($report eq "uptime4")    { &report_uptime4(); }
elsif ($report eq "uptime5")    { &report_uptime5(); }
elsif ($report eq "text")       { &report_text(); }
elsif ($report eq "gov1")       { &report_gov1(); }
elsif ($report eq "cpucount")   { &report_cpucount(); }
elsif ($report eq "osclient")   { &report_osclient(); }
elsif ($report eq "testrpt")    { &report_testrpt(); }
elsif ($report eq "testrpt2")   { &report_testrpt2(); }
elsif ($report eq "testrpt3")   { &report_testrpt3(); }
elsif ($report eq "bill")       { &report_bill(); }
elsif ($report eq "SLA")        { &report_SLA(); }
elsif ($report eq "health")     { &reportHealth(); }
elsif ($report eq "serverListMenu")    { &report_serverListMenu(); }
elsif ($report eq "serverListReport")  { &report_serverList(); }
elsif ($report eq "EVHistory")  { &report_EVHistory(); }
elsif ($report eq "IDEvents")   { &report_IDEvents(); }

else
{
  print "Mode=$dbamonmode Report=($report) Arg1=$arg1 \n";
  print "<br><b>Error:</b> Report $report is not defined.";
}

print "</center></b>";
&msg("Done");

#$goback = -1; 
#print "
#<script language='JavaScript'> function back() { history.go($goback); } </script>
#<hr>
#<span style='font-family:consolas;font-size:8pt;'>
#<a href='javascript:back()'>Return to Last Page</a>
#"; 

print "<hr>\n"; 
&msg("Click BACK"); 

close(LOG);
exit 0;
