#!/usr/local/bin/perl
# !+-------------------------------------------------------------------------
#    Name:  dbamon_runtest.pl
# !*-------------------------------------------------------------------------

chop($P = `basename $0`);
($Pshort = $P) =~ s/\.pl$//g;
$| = 1;
require "cgi_handlers.pl";
use DBI;
$SIG{'INT'} = 'IntHandler';
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
chop($hostname = `hostname`); 
#undef %rqpairs;

#---- Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

#---- See if DBAmon is configured to use Oracle (it should be)
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  #$dbms = "oracle";
  $sql = ""; 
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#-----------------------------------------------------------------------------
sub error 
#-----------------------------------------------------------------------------
{
  local($errorMsg) = $_[0];

  &msg("<font color=red>Fatal Error: $errorMsg</font>");

  if ($DBI::errstr)
  {
    $sqlerror = $DBI::errstr;
    &msg("<font color=red>SQL statement: $sql");
    &msg("<font color=red>SQL error: $sqlerror");
  }

  print "</body>";
  print "</html>";

  &msg("Exiting rc=1"); 
  exit(1);
}

#-----------------------------------------------------------------------------
sub connectDB 
#-----------------------------------------------------------------------------
{
  &msg("Connecting to DBAmon repository - SID=$database"); 
  $dbh = ""; 
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub runTest
#-----------------------------------------------------------------------------
{
  $instances_dir = "/opt/dbamon/adm/instances_test_www"; 
  $lockfile      = "/tmp/${Pshort}_lockfile.txt"; 

  if (! -e "$instances_dir")
  {
    &msg("Creating dir $instances_dir");
    system("remsh $hostname -l dbamon 'mkdir $instances_dir 2>&1'");
  }

  #---- See if anyone else is running test mode - if yes, then quit
  &msg("Checking to see if anyone else is running test mode - lockfile=$lockfile"); 

  #-- does lockfile exist?
  if (-e $lockfile)
  {
    &msg("Lockfile $lockfile does exist"); 
    print "<pre>";
    system("ll $lockfile 2>&1"); 
    system("cat $lockfile 2>&1"); 
    print "</pre>";

    chop ($lockpid = `cat $lockfile | head -1`); 
    &msg("Previous lockpid=$lockpid"); 
    #-- is that pid still running - if yes, then return - if no, then rm lockfile and continue 
    chop($lockplst = `ps -efx | grep -v 'grep' | grep '$lockpid' | grep '$Pshort'`); 
    chop($lockpcnt = `ps -efx | grep -v 'grep' | grep '$lockpid' | grep '$Pshort' | wc -l`); 
    &msg("PIDs running lockpcnt=$lockpcnt"); 
  
    if ($lockpcnt > 0)
    {
      &msg("Someone else is running 'dbamon test' - Terminating"); 
      print "<pre>\n";
      print "$lockplst\n"; 
      system("ll $instances_dir 2>&1"); 
      print "</pre>\n";
      return;
    }
  
    &msg("Removing bogus lockfile $lockfile"); 
    unlink $lockfile;
  }

  #---- save my pid in the file
  system("echo '$$' > $lockfile"); 

  #---- Clean out instances_test_www dir
  &msg("Removing any residual DBC file from $instances_dir"); 
  system("rm $instances_dir/*.dbc 2>/dev/null"); 

  #---- Copy this dbc file to instances_test_www dir
  &error("DBC File $dbcfile does not exist") if ! -e $dbcfile; 
  &msg("Copying DBC file $dbcfile to $instances_dir"); 
  system("cp $dbcfile $instances_dir 2>&1"); 
  print "<pre>";
  system("remsh $hostname -l dbamon 'll $instances_dir/*'"); 
  print "</pre>";

  #---- Set ENV to indicate to test mode that this is WWW mode

  #---- Invoked dbamon test mode
  print "<hr><pre><p STYLE=\"background: black\"><font color=dodgerblue>";
  &msg("Invoking DBAmon test mode"); 
  
  print "<b>";
  
  system("remsh $hostname -l dbamon 'export DBAMON_WWW=1;/opt/dbamon/bin/dbamon test'"); 

  print "</b>";

  &msg("Back from DBAmon test mode\n"); 

  print "</p></font></pre><hr>";

  &msg("Removing lockfile $lockfile"); 
  unlink $lockfile;

  #---- Return to caller 

  ##system("ll $instances_dir/* 2>&1"); 
  $itworked = 1;
  return;
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  local($Signal) = @_;
  &msg("Signal=$Signal received - exiting"); 
  exit(0);
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&get_request;

$dbcfile = (split(/\?/,$ARGV[0]))[0];
$verb    = (split(/\?/,$ARGV[0]))[1];

$dbcfile =~ s/\\$//;

system("env > /tmp/wwwenv.txt");
$client  = $ENV{'REMOTE_HOST'};

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "Content-type: text/html\n\n
  <title>DBAmon Tester</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>DBAmon Tester</center>
  </table>
  <table width=750> $links_include </table>
  <hr>
";

&msg("Starting - dbcfile=$dbcfile client=$client verb=$verb \$\$=$$"); 

##system("echo ' ' | mailx -m -s 'monitor--$Pshort dbcfile=$dbcfile client=$client' bill.border\@thecompany.com"); 

if ($dbcfile !~ /\/instances\//)
{
  &error("This funtion can only be run from the Mode=Production Instance Summary WWW page (not Mode=Test)"); 
}

#if ($dbcfile =~ /instances_test_www\//)
#{
#  $dbcfile =~ s/_www//;
#  &msg("<font color=green>NOTE: Editing DBC dir from instances_test_www to instances_test</font>"); 
#}

#---- Connect to DB (may not need this)
&connectDB;

#---- Run DBAmon in test mode
&runTest;

#---- Finish

if ($itworked)
{
  print "<br>"; 
  &msg("DBAmon Test Mode Output:"); 
  print "<br><iframe src='/dbamon/dbamon_sys_test.html' width=95% height=60%></iframe>\n";

  print "<br>"; 
  &msg("You may now:"); 
  print "<ul>
    <script language='JavaScript'> function back() { history.go(-1); } </script>
    <li><font size=2><b>View the <a href='/dbamon/dbamon_sys_test.html'>DBAmon Test Instance Summary</a> that was just created</b>
    <br>
    <li><font size=2><b><a href='javascript:back()'>Return</a> to return to the Instance Summary that you came from </b></font>
   </ul> 
  ";
}

&msg("Done"); 
exit;
