#---------------------------------------------------------------------------------
#                                                                                
#     XX  XX                                      XX   XX            X           
#      X   X                                       X   X                         
#      X   X                                       XX XX                         
#  XXXXX   XXXXX   XXXX   XXX X    XXXXX  XX XX    XX XX   XXXX    XXX    XX XX  
# X    X   X    X      X   X X X  X     X  XX  X   X X X       X     X     XX  X 
# X    X   X    X  XXXXX   X X X  X     X  X   X   X X X   XXXXX     X     X   X 
# X    X   X    X X    X   X X X  X     X  X   X   X   X  X    X     X     X   X 
# X    X   X    X X    X   X X X  X     X  X   X   X   X  X    X     X     X   X 
#  XXXXXX XXXXXX   XXXX X XX X XX  XXXXX  XXX XXX XXX XXX  XXXX X  XXXXX  XXX XXX
#
#---------------------------------------------------------------------------------
#                                                                                
# Main DBAmon Program (calls almost everything else)
#                                                                                
#---------------------------------------------------------------------------------
{
  #---- ARGs
  # arg=$mod dbamon_tasknum=$i dbamon_alpha=$array[$i] cmdloc=/opt/dbamon/bin
  $arg            = $ARGV[0];
  $dbamon_tasknum = $ARGV[1];
  $dbamon_alpha   = $ARGV[2];
  $cmdloc         = $ARGV[3];
  ##$config_parm{'aaaaaaaa'} = 1;

  #---- debug flags
  $debug      = 0;
  $debug_html = 0;
  $debug_read = 0;
  $debug_opc  = 0;
  $debug_crit = 0;

  my $sql = ""; 
  
  $dashes = "-" x 70;
  $ENV{'DBAMON_MAIN_RUNNING'} = 1; 
  $stop_file = "/tmp/DBAmon_STOP_CMD.txt";

  #---- First iter stuff
  push(@INC,"/opt/dbamon/bin/userexit");

  #---- Default to warm start for now
  if ($ENV{'DBAMON_COLD'} == 1)
  {
    $cold_start = 1;
  }
  else
  {
    $cold_start = 0;
  }

  #---- Version and Release
  ##chop($verrel = `cat /opt/dbamon/bin/verrel`);
  chop($verrel = &fileReadScalar("/opt/dbamon/bin/verrel"));
  
  $dbamon_home = "http://dbamon.com";

  #---- set other variables

  #chop($strdate = `date`);
  $strdate = &getdate; 

  chop($thisos = `uname`);

  $rc_save = 0;

  $pid = $$;

  $cmdb_sn_flag = 1; 

  #---- Write my pid and mode to a file
  $time_processes = time;
  #chop($ts_processes = `date +%Y/%m/%d-%H:%M:%S`);
  $ts_processes = &getdate; 
  $modeout = $arg . $dbamon_tasknum;
  system("echo '$pid $modeout $time_processes $ts_processes $dbamon_alpha ' >> /opt/dbamon/adm/processes_${arg}.txt");

  $optdir="/opt/dbamon";

  if ($arg eq "test") 
  {
    $tmpdir="/opt/dbamon/tmp/test_${dbamon_tasknum}";
    $rptdir="/opt/dbamon/dat/reports/test";
  }
  else
  {
    $tmpdir="/opt/dbamon/tmp/prod_${dbamon_tasknum}";
    $rptdir="/opt/dbamon/dat/reports";
  }

  #---- Create tmpdir if it does not exist
  system("mkdir $tmpdir          2>/dev/null") if ! -e "$tmpdir";
  system("mkdir $tmpdir/debug    2>/dev/null") if ! -e "$tmpdir/debug";
  system("mkdir $tmpdir/probeout 2>/dev/null") if ! -e "$tmpdir/probeout";

  #---- Some old cold start logic
  #if ($cold_start && -e "$tmpdir")
  #{
  #  system("rm -fr $tmpdir 2>/dev/null");
  #}
  #else
  #{
  #}

  $pgmdir="/opt/dbamon/bin";
  $admdir="/opt/dbamon/adm";
  $hstdir="/opt/dbamon/dat/history";
  $inhibdir="/opt/dbamon/adm/inhibit";

  $remshlog="$tmpdir/remsherr_$dbamon_tasknum";
  $pinglog ="$tmpdir/pingerr_$dbamon_tasknum";
  $parmall ="$tmpdir/dbamonrc_$dbamon_tasknum";

  # Cleanup old temp files
  system("rm $tmpdir/dbamon_tmp*${dbamon_tasknum} > /dev/null 2>&1");

  $tmpfl1="$tmpdir/dbamon_tmp1_${dbamon_tasknum}";
  $tmpfl2="$tmpdir/dbamon_tmp2_${dbamon_tasknum}";
  $tmpfl3="$tmpdir/dbamon_tmp3_${dbamon_tasknum}";
  $tmpfl4="$tmpdir/dbamon_tmp4_${dbamon_tasknum}";
  $tmpfl5="$tmpdir/dbamon_tmp5_${dbamon_tasknum}";
  $tmpfl6="$tmpdir/dbamon_tmp6_${dbamon_tasknum}";
  $tmpfl7="$tmpdir/dbamon_tmp7_${dbamon_tasknum}";
  $tmpfl8="$tmpdir/dbamon_tmp8_${dbamon_tasknum}";
  $tmpflt="$tmpdir/dbamon_tmpt_${dbamon_tasknum}";
  $sqlfil="$tmpdir/dbamon_sqlf_${dbamon_tasknum}";

  $tmplcl="/opt/dbamon/tmp/dbamon_arc_sql_${dbamon_tasknum}";  # dbamon_arch_onarch output
  $tmprmt="/tmp/dbamon_arc.sql";    # on monitored system

  $logfile="dummy";
  $wheretolog="S";

  $f_s = "<font size=2>";
  $f_e = "</font>";

  chop($dbamon_userid = `id -u -n`);

  chop($wsname = lc `hostname`);

  if (-e '/etc/resolv.conf' || $g_use_dns eq "Y")
  {
    chop($wsnamef = `nslookup $wsname | grep 'Name:' | awk '{ print \$2 }'`);
    @z = split(/\./,$wsnamef);
    $company = $z[$#z -1];
  }

  &logit("DBAmonMain - Starting - arg=$arg wsname=$wsname wsnamef=$wsnamef company=$company #=$#z");

  if ($arg eq "test")
  {
    $mode="test";
    $parmfl="$optdir/adm/dbamonrc_test";
    $insertdb="database dbamon_test;" ;
    if ($ENV{'DBAMON_WWW'} == 1)
    {
      $parmdir="$optdir/adm/instances_test_www";
    }
    else
    {
      $parmdir="$optdir/adm/instances_test";
    }
  }
  else
  {
    $mode="prod";
    $parmfl="$optdir/adm/dbamonrc";
    $insertdb="database dbamon;" ;
    $parmdir="$optdir/adm/instances";
  }

  $mode_ucfirst = ucfirst($mode); 
  $mode_firstletter = substr($mode_ucfirst,0,1);

  &logit("Mode=$mode ($mode_ucfirst) pid=$pid dbamon_tasknum=$dbamon_tasknum");

  #---- Verify that all DBAmon directories exist
  &verifyDirs();

  #---- Read dbamonrc and DBC files
  &readConfig();

  #---- 2011/01/06 BB - These are now in the dbamonrc file
  ##$table_bgcolor = "cornsilk";
  ##$table_headbgcolor = "slateblue";
  $table_bgcolor = $www_table_bgcolor; 
  $table_headbgcolor = $www_table_headbgcolor;
  $table_rowcolor = "cornsilk"; 
  $table_cellcolor = "snow"; 

  #---- Use this later
  $admin_email_url = "<a href='mailto:$admin_email'><b>DBAmon Administrator</b></a>"; 

  #---- Style definitions
  $style_micro = "style='font-family:$www_font;font-size:8pt'";
  $style_tiny  = "style='font-family:$www_font;font-size:8pt'";
  $style_tinyb = "style='font-family:$www_font;font-size:8pt;font-weight:bold'";
  $style_med   = "style='font-family:$www_font;font-size:10pt'";
  $style_large = "style='font-family:$www_font;font-size:13pt'";
  $style_th    = "style='font-family:$www_font;font-size:9pt'";
  $style_td    = "style='font-family:$www_font;font-size:9pt'";

  $color_good = "palegreen"; 
  $color_warn = "yellow"; 
  $color_bad  = "lightpink"; 

  $f_trow = "<span $style_th>"; 

  #---- We already read this in readConfig???
  ##chop($use_oracle  = `grep 'Use_Oracle:' $parmfl | grep -v '^#' | awk '{ print \$2 }'`);

  if ($use_oracle eq "Y")
  {
    $insertdb = "-- connect?";
    &logit("Connecting to Oracle Repository DB - ORACLE_SID=$ENV{'ORACLE_SID'}");
    &connectDB;
  }
  elsif ($use_mssql eq "Y")
  {
    &logit("Connecting to MSSQL Repository DB - Database 'dbamon' in mssql_instance=$mssql_instance");
    &connectDB;
  }
  else 
  {
    &error_fatal("Use_Oracle: or Use_MSSQL: MUST Be specified in dbamonrc ");
  }

  #---- Verify that all DBAmon tables exist
  &verifyTables();

  $msg = sprintf("SYSTEM values - sleep_time=%s iterations=%s dbamon_admin=%s",$sleep_time,$iterations,$dbamon_admin);
  &logit($msg);
  $msg = sprintf("  html_events_dir=%s df_dbms=%s",$html_events_dir,$df_dbms);
  &logit($msg);

  #---- This clears all outstanding events - 2011/01/30 - I will disable this for now so that all events aren't reissued during a restart
  if ($cold_start)
  {
    &logit("DBAmon COLD Starting - Event Files reset");
    system("rm $tmpdir/dbamon_savemsg_next > /dev/null 2>&1");
    system("rm $tmpdir/dbamon_savemsg_this > /dev/null 2>&1");
  }
  else
  {
    $event_files  = `ls -l $tmpdir/dbamon_savemsg_next 2>&1`; 
    $event_files .= `ls -l $tmpdir/dbamon_savemsg_next 2>&1`; 
    $event_files =~ s/\n\n/\n/;
    $event_files =~ s/\n$//;
    &logit("DBAmon WARM Starting - Event Files:\n$event_files");
  }

  $outmode = $mode;
  if ($outmode ne "") 
  {
    $outmode = "prod"
  }

  $msg = sprintf("Version %s Starting",$verrel);
  &logit($msg);
  &log_msg($msg);
  $msg = sprintf("pgmdir=%s arg=%s tmpdir=%s insertdb=%s company=%s pid=%s",$pgmdir,$arg,$tmpdir,$insertdb,$company,$pid);
  &logit($msg);
  &log_msg($msg);
  $msg = sprintf("dbamon_userid=%s dbamon_tasknum=%s dbamon_alpha=%s",$dbamon_userid,$dbamon_tasknum,$dbamon_alpha);
  &logit($msg);
  &log_msg($msg);

  $save_flag = 0;
 
  #---- CYGWIN mem monitoring vars
  $cygwin_mem_leak = 1; 
  $cygwin_mem_max  = 1024;  
  $cygwin_t_mem    = 97;  

  #---- Check DBAmon version against latest on dbamon_home
  &check_sw();

  #---------------------------------------------------------------------------------
  # DBAmon Iteration LOOP Start
  #---------------------------------------------------------------------------------

  for ($iter_count = 1; $iter_count <= $iterations; $iter_count++)
  {
    $time_start = time;

    #---- Reset instance count
    $iter_instance_count      = 0; 
    $instance_dur_worst_title = "?";
    $instance_dur_worst_secs  = -1;

    #---- Start of iteration stuff
    $msg = sprintf("Start of Iteration #%s",$iter_count); 
    &logit($msg);
    &heartbeat("Start_of_Iteration"); 

    #---- Clear some vars
    &varsInit;
    #require "varsInit_Req.pl";

    #---- As a test, disconnect and reconnect to repos 
    if ($cygwin_mem_leak)
    {
      &logit("Disconnecting from DBAmon Repository DB"); 
      &disconnectDB;
      &logit("Connecting to DBAmon Repository DB"); 
      &connectDB;
    }

    #---- Stop if STOP FILE exists
    if (-e "$stop_file") 
    {
      &logit("NOTE - DBAmon STOP_FILE=$stop_file found - Exiting"); 
      unlink $stop_file; 
      last;
    }
    else
    {
      &logit("NOTE - DBAmon STOP_FILE=$stop_file Not found - Continuing"); 
    }

    #---- Start of iteration housekeeping
    &begin_stuff();

    #---- Read distribtion list data (moved from readDBCFile)
    &readDist;

    #---- Read DBC files
    if ($ENV{'DBAMON_READDBCDB'} ne "")
    {
      &readDBCDB();
    }
    else  
    {
      &readDBCFile();
    }

    if ($iter_count == 1)
    {
      # Check license key
      # Check our license key
      #&logit("Checking license key");
      #if (system("/opt/dbamon/bin/keychk $high_host $dbamon_admin $verrel $dbmslist $mode") != 0)
      #{
      #	$msg = "ERROR - Your license key in /opt/dbamon/adm/key.txt is not valid or expired - see preceeding message";
      #	&error_msg($msg);
      #	exit 1;
      #}
    }

    #---- Download Software
    &run_monitor("DownloadSW");

    ##print "DEBUG - dbmslist=$dbmslist\n"; 

    if (index($dbmslist,"OracleNT") > -1)
    {
      &run_monitor("orantUp");
      &run_monitor("orantPerf");
      &run_monitor("orantPerf2");
      &run_monitor("orantTSFull");
      &run_monitor("orantArclog");
      &run_monitor("orantDatafiles");
      &run_monitor("orantBkup");
    }
    else
    {
      $msg = "(No OracleNT Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"MSSQL") > -1)
    {
      &run_monitor("sqlUp");
      &run_monitor("sqlTLog");
      &run_monitor("sqlBkup");
      &run_monitor("sqlBkupTLog");
      &run_monitor("sqlAlerts");
      &run_monitor("sqlFG");          #---- 2011/01/05 BB - New checks for filegroups 
      &run_monitor("sqlPerf");        #---- 2011/02/07 BB - New perf data collection
      &run_monitor("sqlJobs");        #---- 2011/02/16 BB - New jobs data collection
      &run_monitor("sqlTrends");      #---- 2013/07/07 BB - New trends analysis
      &run_monitor("sqlSaveConfig");  #---- 2011/03/23 BB - New config save 
    }
    else
    {
      $msg = "(No MSSQL Instances to Monitor)";
      &logit($msg)
    }

    if (index($dbmslist,"SAP") > -1)
    {
      &run_monitor("sapUp");
    }
    else
    {
      $msg = "(No SAP Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"OracleApps") > -1)
    {
      &run_monitor("oraapUp");
    }
    else
    {
      $msg = "(No OracleApps Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"OracleDB") > -1)
    {
      &run_monitor("oraUp");
      &run_monitor("oraSaveCfg");
      &run_monitor("oraSec");
      &run_monitor("oraInSync");
      &run_monitor("oraSGA");
      &run_monitor("oraLsnr");
      &run_monitor("oraAuditSes");
      &run_monitor("oraDatafiles");
      &run_monitor("oraArclog");
      &run_monitor("oraBkup");
      &run_monitor("oraBkupArc");
      &run_monitor("oraTSFull");
      &run_monitor("oraAlerts");
      &run_monitor("oraExtents");
      &run_monitor("oraPerf");
    }
    else
    {
      $msg = "(No OracleDB Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"Informix") > -1)
    {
      &run_monitor("infUp");         # Informix up
      &run_monitor("infLongTX");     # Long tx
      &run_monitor("infChkDup");     # Dup onconfig parms
      &run_monitor("infSWVer");      # Ifmx vers
      &run_monitor("infChunksDown"); # Chunks down 
      &run_monitor("infSaveCfg");    # Save onconfig
      &run_monitor("infLocks");      # Locks exceeded
      &run_monitor("infNFile");      # NFILEs
      &run_monitor("infCkpt");       # Checkpoint dur
      &run_monitor("infShmem");      # Shmem segs
      &run_monitor("infExtents");    # TBL extents
      &run_monitor("infDBS");        # DBSpaces
      &run_monitor("infCleaners");   # Cleaners
      &run_monitor("infLlogs");      # Logical logs
      &run_monitor("infArc");        # Backup age
      &run_monitor("infHDR");        # HDR
      &run_monitor("infMLog");       # Message log
      &run_monitor("infPerf");       # Perf stuff
    }
    else
    {
      $msg = "(No Informix Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"OSWin") > -1)
    {
      &run_monitor("osWinUp");
      &run_monitor("osWinPerf");     
    }
    else
    {
      $msg = "(No OSWin Instances to Monitor)";
      &logit($msg)
    }

    #---- Print Summary
    &heartbeat("Invoking_summarize"); 
    $this_function = "";
    &summarize();

    #---- End of iteration housekeeping
    &end_stuff();

    #---- Calc iteration duration
    $time_end = time;
    $dur = $time_end - $time_start;

    #---- Write to task table
    &logit("Inserting into DBAMON.TASK and TASK_HISTORY");

    #---- Insert into DBAMON.TASK
    if ($dbamon_alpha eq "") { $z = "*"; }
    else                     { $z = $dbamon_alpha; }
    $sql  = "
      insert into dbamon.task
      (dbamonmode,pid,starttime_num,starttime_char,alpha,iter_num,iter_dur,num_instances)
      values
      (\'$modeout\',\'$pid\', \'$time_processes\', \'$ts_processes\', \'$z\', \'$iter_count\',\'$dur\',\'$high_host\')
    ";
    &runSQL($sql);
   
    #---- Insert into DBAMON.TASK_HISTORY
    $sql  = "
      insert into dbamon.task_history
      (th_dbamonmode, th_iter_seq, th_num_instances, th_dur, th_ts_num)
      values
      (\'$modeout\', $g_thisiter_seq, $high_host, $dur, $time_end )
    ";
    &runSQL($sql);
   
    #---- Recreate the summary WWW page for this mode
    &logit("Updating repository with Event Data for this iteration");
    &eventDB;

    #---- Call dbamon_DBMS_sumread to recreate the summary WWW page for this mode
    &heartbeat("Invoking_sumread"); 
    if ($use_oracle eq "Y")
    {
      $sumread_pgm = "dbamon_ora_sumread"; 
    }
    elsif ($use_mssql eq "Y")
    {
      $sumread_pgm = "dbamon_mssql_sumread"; 
    }
    $sumread_log = "/opt/dbamon/log/$sumread_pgm.log"; 
    &logit("Invoking $sumread_pgm.pl - sumread_log=$sumread_log");

    ##$cmd = "$pgmdir/$sumread_pgm.pl $mode > $tmpfl8 2>&1";
    $cmd = "$pgmdir/$sumread_pgm.pl $mode > $sumread_log 2>&1";
    $stime_sumread = time;
    $rc = system($cmd);
    if ($rc != 0) { $rc = $rc / 256; }
    &logit("$sumread_pgm.pl ended with rc=2 (Normal)") if $rc == 2;
    if ($rc != 0 && $rc != 2)
    {
      $msg = sprintf("$sumread_pgm.pl Error - rc=%s - Check sumread_log=$sumread_log",$rc);
      &logit($msg);
      ##&error_msg($msg,'',$sumread_log);
      &error_fatal($msg);
      #---- Save a copy of this log file
      system("cp $sumread_log /tmp/${sumread_pgm}_error.log"); 
    }
    $etime_sumread = time - $stime_sumread;
    &logit("$sumread_pgm.pl Ended with rc=$rc - Elapsed time: $etime_sumread"); 
    system("cp $sumread_log /tmp/$sumread_pgm.log"); 

    &heartbeat("End_of_Iteration"); 
    &logit($dashes);
    $msg = sprintf("End of Iteration %s of %s",$iter_count,$iterations);
    &logit($msg);

    my $dur_mins = int($dur / 60);
    my $dur_avg_secs = sprintf("%.2f", $dur / $iter_instance_count) if $iter_instance_count > 0; 
    $msg = sprintf("Iteration Dur: %s Seconds (%s Mins) - Instances Processed: %s - Slowest Instance/Secs: %s/%s - Avg Secs/Instance: %s",
                   $dur,$dur_mins, $iter_instance_count, $instance_dur_worst_title, $instance_dur_worst_secs, $dur_avg_secs);
    &logit($msg);

    #---- Clear some vars again
    &varsInit;
    #require "varsInit_Req.pl";

    if (1 == 0)  #---- 5.57.A 2017/07/07 - No longer needed
    {
      #----
      #---- MEMLEAK - Start - look for memory leak
      #----
      use Devel::Size qw(size total_size);
      $Devel::Size::warn = 0;
      foreach my $entry ( sort keys %main:: )
      {
	next if $entry =~ /^\_/;
	next if $entry =~ /MAXBUF/ || $entry =~ /BITS/;
	$perl = "\$zlen=length(\$${entry})\;";
	eval $perl;
	&logit("MEMLEAK_VAR - Variable=$entry Len=$zlen") if $zlen > 8000;
      }
      foreach my $entry ( sort keys %:: )
      {
	next if $entry =~ /^\_/;
	next if length($entry) < 5;
	next if $entry =~ /MAXBUF/ || $entry =~ /BITS/ || $entry =~ /INC/;
	$perl = "\$zcnt=\$\#${entry}\;";
	eval $perl;
	next if $zcnt == -1 || $zcnt eq "";
	##$perl = "\$zlen = 0; foreach (\@${entry} ) { \$zlen += length(\$_) }  ";
	$perl = "\$zlen = total_size(\\\@$entry);";
	eval $perl;
	&logit("MEMLEAK_ARRAY - Array=$entry EntryCnt=$zcnt TotLen=$zlen") if $zlen > 8000;
      }
      foreach my $entry ( sort keys %:: )
      {
	next if $entry =~ /^\_/;
	next if length($entry) < 4;
	next if $entry =~ /MAXBUF/ || $entry =~ /BITS/ || $entry =~ /INC/;
	$perl = "\$zlen = 0; \$zcnt = 0; foreach ( sort keys \%${entry} ) { \$zcnt++;  }  ";
	eval $perl;
	next if $zlen == 0 || $zlen eq "";
	#---- New using total_size
	$perl = "\$zlen = total_size(\\\%$entry);";
	eval $perl;
	&logit("MEMLEAK_HASH - Hash=$entry TotLen=$zlen EntryCnt=$zcnt") if $zcnt > 100 || $zlen > 1000;
      }
    }

    if (1 == 0)   #---- 2013/07/09 No longer needed
    {
      &logit("MEMLEAK_OUT - Writing to /tmp/dbamon_memleak_$modeout.txt");  
      open (LEAKOUT, ">>/tmp/dbamon_memleak_$modeout.txt"); 
      my $zdate = getdate(); 
      print LEAKOUT "$zdate - START - Iteration=$iter_count\n"; 
      printf LEAKOUT "%30s: %d\n", $_, total_size( $::{ $_ } ) for keys %::;;
      print LEAKOUT "$zdate - END   - Iteration=$iter_count\n"; 
      close(LEAKOUT); 
    }
 
    #----
    #---- MEMLEAK - End - look for memory leak
    #----

    #---- End of iteration housekeeping 
    if ($thisos =~ /cygwin/i)
    {
      open (ZPROC, "/proc/$$/stat");
      while (<ZPROC>)
      {
        $rss_size = (split(/\s/,$_)) [22];
      }
      close(ZPROC);
      $rss_size_kb        = int($rss_size / (1024)); 
      $rss_size_mb        = int($rss_size / (1024*1024)); 
      $rss_size_kb_growth = $rss_size_kb - $last_rss_size_kb; 
      $last_rss_size_kb = $rss_size_kb;
      &logit("CYGWIN Mem Usage: RSSSizeKB=$rss_size_kb RSSGrowthKB=$rss_size_kb_growth"); 
      $cygwin_mem_pct = sprintf("%.2f",(($rss_size_mb / $cygwin_mem_max) * 100));
      &logit("CYGWIN Mem Usage: We are now at ${cygwin_mem_pct}% of MAX MEM of $cygwin_mem_max (MB)"); 
      if ($cygwin_mem_pct >= $cygwin_t_mem) 
      {
	&logit("CYGWIN Mem Usage: STOPPING DBAmon because we are >= threshold of ${cygwin_t_mem}%"); 
	last;
      }
    }

    #---- Stop if STOP FILE exists 
    if (-e "$stop_file") 
    {
      &logit("NOTE - DBAmon STOP_FILE=$stop_file found - Exiting"); 
      unlink $stop_file; 
      last;
    }
    else
    {
      &logit("NOTE - DBAmon STOP_FILE=$stop_file Not found - Continuing"); 
    }

    #---- Sleep until Iter_Min_Secs
    if ($iter_count < $iterations && $iter_min_secs ne "" && $dur < $iter_min_secs)
    {
      &logit("This iteration ran for less than dbamonrc Iter_Min_Secs: value of $iter_min_secs");
      $st = $iter_min_secs - $dur;
      my $st_mins = int($st / 60); 
      &logit("Sleeping for $st seconds ($st_mins minutes) before starting the next iteration");
      sleep($st);
    }

    #---- Sleep
    if ($sleep_time > 0)
    {
      &logit("Sleeping for dbamonrc Sleeptime: value of $sleep_time seconds");
      &logit($dashes);

      if (system("sleep $sleep_time") != 0)
      {
	$msg = sprintf("Cancelled");
	&logit($msg);
	&log_msg($msg);
	#if ($cold_start)
	#{
        #  system("rm $optdir/tmp/dbamon_savemsg_next > /dev/null 2>&1");
        #  system("rm $optdir/tmp/dbamon_savemsg_this > /dev/null 2>&1");
        #}
	exit;
      }
    }
  }

  #---------------------------------------------------------------------------------
  # DBAmon Iteration LOOP End
  #---------------------------------------------------------------------------------

  &logit($dashes);
  &logit("All DBAmon Iterations Completed - Exiting");
}
1;
