#-------------------------------------------------------------------------------
sub end_stuff
#-------------------------------------------------------------------------------
{
  #---- End of iteration stuff

  use File::Copy;

  &logit("End of Iteration Tasks - Starting"); 
  system("rm $tmpdir/dbamon_tmp* > /dev/null 2>&1");

  $date = &getdate; 
  my $sql = ""; 

  $msgid = "DBA501N";
  &log_msg("Iteration End Time: $date");

  $i = 1;
  ##print "test moving i=" i " high_host=" high_host
  while ($i <= $high_host)
  {
    if ($html_events_flag[$i]) 
    {
      #---- Old
      ## $rc = system("mv $html_events[$i] $html_events_perm[$i]");
      ## &error("Cannot MOVE events file - $!") if $rc != 0;
      #---- New
      open(EV_IN,  "$html_events[$i]")       || &error_msg("Cannot open input $html_events[$i] - $!"); 
      open(EV_OUT, ">$html_events_perm[$i]") || &error_msg("Cannot open output $html_events_perm[$i] - $!"); 

      my $ev_reccnt = 0; 
      while(<EV_IN>) 
      {
        $ev_reccnt++; 

        if (/PlaceIndexHere/)
        {
           my $zdata = "
           <div style='font-family:$www_font;font-size:9pt'>
           <b>Outstanding Events:</b>
           <ol>
             $html_events_index[$i]  
           </ol>
           </div>  
           "; 
           print EV_OUT $zdata; 
           next;
        } 

        print EV_OUT; 
      }
      ##&logit("DEBUG-End - Wrote $ev_reccnt records from $html_events[$i] to $html_events_perm[$i]"); 
      close(EV_IN); 
      close(EV_OUT); 
      
      unlink "$html_events[$i]";
    }
    if ($html_details_flag[$i]) 
    {
      #---- Old
      #$rc = system("mv $html_details[$i] $html_details_perm[$i]");
      #&error("Cannot MOVE details file - $!") if $rc != 0;
      #---- New
      move("$html_details[$i]", "$html_details_perm[$i]") || &error("Cannot MOVE details file ($html_details[$i]) - $!") if -e "$html_details[$i]"; 
    }
    $i++;
  }

  #---- Keep TASK_EVENT_CACHE at only the last 7 days
  &logit("  Deleting rows from DBAMON.TASK_EVENT_CACHE > 7 days old"); 
  $sql = "delete FROM dbamon.task_event_cache where te_ts < DATEADD(dd,-7,getdate())"; 
  $dbh->do($sql) || &error_msg('Failed_on_DB_do_delete_ES67');

  #---- Delete EVENTS rows > 30 days old wher ticket=SD 
  &logit("  Deleting ticket=SD rows from DBAMON.EVENTS > 14 days old"); 
  $sql = "delete FROM dbamon.events where ticket = 'SD' and ts < DATEADD(dd,-14,getdate())"; 
  $dbh->do($sql) || &error_msg('Failed_on_DB_do_delete_ES76');

  #---- Copy INSTANCES table to INSTANCES_PERF
  if ($mode eq "prod")
  {
    &logit("  Creating new INSTANCES_PERM table from INSTANCES"); 
    $sql = "IF EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = 'instances_perm')
  BEGIN
    DROP TABLE [dbamon].[instances_perm] 
  END"; 
    $dbh->do($sql) || &error_msg('Failed_on_DB_do_delete_ES84');

    $sql = "select * into dbamon.instances_perm FROM dbamon.instances"; 
    $dbh->do($sql) || &error_msg('Failed_on_DB_do_delete_ES87');
  }

  &logit("End of Iteration Tasks - Done"); 
}
#-------------------------------------------------------------------------------

1;
