# -----------------------------------------------------------------------------
# Changes:
#   07Jun06 BB - The test for meeting the thresholds changed from > to >=
# -----------------------------------------------------------------------------
sub infDBS
{
  ($thishost) = @_;

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if ($chunks_ok[$thishost] ne "Y")
  {
    &logit("(Chunk(s) down)",$thishost);
    return 1;
  }

  if ($t_diskcrit[$thishost] eq "" && $t_diskwarn[$thishost] eq "")
  {
    logit("T_DBSpace_Full: Not Specified",$thishost);
    &history_dummy($thishost);
    return;
  }

  # 3.18 - CLEANERS weren't checked if we don't run this 
  #if (dr_status[i_rm] == "(Sec)" ) 
  #{
  #  msg = sprintf("(DBSpace Check Not Applicable for HDR Secondary)")
  #  logit($msg,$thishost);
  #  return 1 
  #}

  ##print os_version[$thishost]
  ##print substr(os_version[$thishost],1,1) 

  ##if (substr(os_version[$thishost],1,1) == "0")
  ##{
  ##  msg = sprintf("Locks Used checking only works on HP-UX version >= 10")
  ##  logit($msg,$thishost);
  ##  return 0 
  ##}

  $warn_flag = 0;
  $crit_flag = 0;

  $warndbs[$thishost] = 0;
  $critdbs[$thishost] = 0;

  #
  # Run perl pgm to query dbspaces (sysmaster)
  #

  &remsh("onstat -;export PATH=\$PATH:$infdir[$thishost]/bin;$probe[$thishost] dbs",$tmpfl2,$thishost);
  ##print "test:\n";
  ##system("cat $tmpfl2");

  if (system("grep 'Fatal' $tmpfl2 > /dev/null 2>&1") == 0)
  {
    &event("C",$thishost,"Fatal dbaccess Error Checking DBSpaces","DBSErr","DBA232C",$tmpfl2);
    &downloadFlagOff($thishost);
    return 1;
  }

  #
  # Create Disk Space Report Heading
  #

  &logDetails($thishost,"<h3>Informix DBSpaces</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>DBSpace<th>Chunks<th>Size (MB)<th>Free (MB)<th>Used (MB)<th>Percent Full<th>Status:<br>W=Warning<br>C=Critical</tr>");

  $total_size = 0;
  $total_free = 0;
  $total_used = 0;
  $total_chks = 0;

  if ($g_history_to_file eq "Y")
  {
    #  
    # If needed, create DBSPACE History File
    #
    chop($filedate = `date +%C%y.%m.%d `);
    chop($filetime = `date +%H:%M:%S `);
    $hist_flag = 0;
    if (system("grep '$titleraw[$thishost]' ${hstdir}/dbspaces/$filedate > /dev/null 2>&1") != 0)
    {
      &logit("Creating dbspace history data",$thishost);
      system("rm $tmpflt > /dev/null 2>&1");
      $hist_flag = 1;    
    }
  }

  #
  # Read report
  #

  $error_flag = 0;
  $error_text = "";

  open(TMPFL2, "$tmpfl2"  ) || &error_msg("Can't open input $tmpfl2 - $!");
  while(<TMPFL2>)
  {
    &parse;

    if ($F1 eq "kio")
    {
      $kio[$thishost] = 1;
      ##print "kio=$kio[$thishost] \n";
    }

    if ($F1 eq "WSTATS")
    {
      $wstats[$thishost] = $F2;
      ##print "wstats=$wstats[$thishost] \n";
    }

    if ($F1 eq "ERROR:")
    {
      $error_flag = 1;
      chop($error_text = $F0);
    }

    if ($F1 eq "SHMVIRTSIZE")
    {
      $shmvirtsize[$thishost] = $F2;
      ##print "shmvirtsize=$shmvirtsize[$thishost] \n";
    }

    if ($F1 eq "LTAPEDEV")
    {
      $ltapedev[$thishost] = $F2
    }

    if ($F1 eq "LRUS")
    {
      $lrus[$thishost] = $F2;
    }

    if ($F1 eq "CLEANERS")
    {
      $cleaners[$thishost] = $F2;
    }

    if ($F1 eq "NUMAIOVPS")
    {
      $numaiovps[$thishost] = $F2;
    }

    if ($F1 eq "AIORAT:")
    {
      $aiorat[$thishost] = $F2;
      $aiocur[$thishost] = $F8;
      ##print "$title[$thishost] aiorat=$aiorat[$thishost] \n";
    }

    if ($F1 eq "SAP:")
    {
      $sapkern[$thishost] = $F2;
      $saprlse[$thishost] = $F3;
    }

    if ($F1 eq "normal")
    {
      $shmmagic[$thishost] = 1;
    }

    if ($F1 eq "THIS:")
    {
      $dbspace = $F2;
      $nchunks = $F3;
      $dbssize = $F4;
      $dbsfree = $F5;
      $dbsused = $F6;
      $dbspct  = $F7 + 0;
      $dbspre = substr($dbspace,0,4);

      if ($dbspace =~ /log/ || $dbspace =~ /phy/)
      {
        $dbspace_log = 1;
      }
      else
      {
        $dbspace_log = 0;
      }
 
      #
      # Check vs. threshold
      #

      ##print "dbspct=" dbspct 
      ##print "dbspre=$dbspre  \n";
      ##print "tdcrit=" t_diskcrit[$thishost]
      ##print "tdwarn=" t_diskwarn[$thishost]
      ##print "tdfree=" t_freespace[$thishost]
 
      $status = "";
      $color = "lime";

      if ($dr_status[$thishost] ne "(Sec)" && $dbspct >= $t_diskcrit[$thishost] && $dbsfree < $t_freespace[$thishost] && $dbspace_log == 0)
      {
        $status = "C";
        $color = "red";
        if ($critdbs[$thishost] == 0)
        {
          $critdbs[$thishost] = 1;
        }

        open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
        $msg = " DBSpace           Chunks   Size (MB)   Free (MB)   Pct Full";
	print TMPFL6 "$msg \n";
	$msg = sprintf(" %-20s  %2s  %10d  %10d    %6.1d%%",$dbspace,$nchunks,$dbssize,$dbsfree,$dbspct);
	print TMPFL6 "$msg \n";
	close(TMPFL6);

        &event("C",$thishost,"DBSpace $dbspace (${dbspct}% full ${dbsfree}MB free) exceeds critical threshold of $t_diskcrit[$thishost]","DBS","DBA250C",$tmpfl6);
	$crit_flag=1;
      }
      elsif ($dr_status[$thishost] ne "(Sec)" && $dbspct >= $t_diskwarn[$thishost] && $dbsfree < $t_freespace[$thishost] && $dbspace_log == 0)
      {
        $status = "W";
        $color = "yellow";
        if ($warndbs[$thishost] == 0)
        {
          $warndbs[$thishost] = 1;
        }

        open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
	$msg = " DBSpace           Chunks   Size (MB)   Free (MB)   Pct Full";
	print TMPFL6 "$msg \n";
	$msg = sprintf(" %-20s  %2s  %10d  %10d    %6.1d%%",$dbspace,$nchunks,$dbssize,$dbsfree,$dbspct);
	print TMPFL6 "$msg \n";
	close(TMPFL6);

        &event("W",$thishost,"DBSpace $dbspace (${dbspct}% full ${dbsfree}MB free) exceeds warning threshold of $t_diskwarn[$thishost]","DBS","DBA251W",$tmpfl6);
	$warn_flag = 1;
      }

      &logDetails($thishost,"<tr bgcolor=$color><td><h5>$dbspace<td align=right><h5>$nchunks<td align=right><h5>$dbssize<td align=right><h5>$dbsfree<td align=right><h5>$dbsused<td align=right><h5>$dbspct<td><h5>$status" );

      $total_size += $dbssize;
      $total_free += $dbsfree;
      $total_used += $dbsused;
      $total_chks += $nchunks;

      if ($g_history_to_file eq "Y")
      {
	#
	# Create hist data line
	#
	if ($hist_flag)
	{
	  $msg = sprintf(" %-20s  %2s  %9.1d  %9.1d  %9.1d    %6.0f%%",$dbspace,$nchunks,$dbssize,$dbsfree,$dbsused,$dbspct);
	  system("echo '$filedate $filetime $title[$thishost] $dbspace $nchunks $dbssize $dbsused' >> $tmpflt");  # Write to tmp file
	}
      }

      &histCreate("infDBS()",$thishost,"SPC",$dbspace,$dbssize,$dbsused);
      $gbtot_informix += ($dbssize / 1000);
    }
  }
  close(TMPFL2);

  #if (substr(sw_version[$thishost],1,1) < "7")
  #{
  #  msg = sprintf(" (DBSpace Checking Not Possible With Informix Version < 5)")
  #  print msg >> report_path
  #  msg = sprintf("DBSpace Checking only works on Informix version >= 7")
  #  logit($msg,$thishost);
  #  return 0 
  #} 

  if ($error_flag)
  {
    &event("C",$thishost,"DBS Reporting Error: $error_text","DBSErr","DBA221C",$tmpfl2);
    return 1;
  }

  if ($total_size == 0)
  {
    #$msg = sprintf("infDBS() - %s - zero divide #5",$title[$thishost]);
    #&logit($msg,$thishost);
    #system("cat $tmpfl2 >> $logfile");
    #&error_msg($msg,$thishost,$tmpfl2);
    #system("cat $tmpfl2");
    #$download_flag[$thishost] = 0;
    $totpct = 0;
    if (system("grep 'ISAM error: no free disk space' $tmpfl2 > /dev/null 2>&1") == 0)
    {
      &event("C",$thishost,"TEMP DBSpace Full - DBS Probe Error","DBSTmpFull","DBA222C",$tmpfl2);
    }
    else
    {
      &event("C",$thishost,"DBS Reporting Error: total_size=0 - Probably dbaccess Error","DBSErr","DBA221C",$tmpfl2);
    }
  }
  else
  {
    $totpct = int( 100 * ($total_used / $total_size));
  }
  logDetails($thishost,"<tr bgcolor=slate><td><b>Totals:</b><td align=right><h5>$total_chks<td align=right><h5>$total_size<td align=right><h5>$total_free<td align=right><h5>$total_used<td align=right><h5>$totpct");
  logDetails($thishost,"</table><hr>");

  $system_size[$thishost] = $total_size / 1000;
  $system_used[$thishost] = $total_used / 1000;
  $grand_total_size += $total_size / 1000;

  if ($warn_flag == 0 && $crit_flag == 0)
  {
    logit("OK",$thishost);
  }

  if ($g_history_to_file eq "Y")
  {
    # Write temp dbspace hist file to this dates file
    if ($hist_flag)
    {
      system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");
    }
  }
}
# -----------------------------------------------------------------------------
1;
