# -----------------------------------------------------------------------------
sub orantPerf
# -----------------------------------------------------------------------------
# Changes:
#   18Jan05 BB - Changed short text of bufhit event to contain percent
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  if ($t_readhit[$thishost] eq "N")
  {
    &logit("(Not Selected (T_Read_Hit: is N)",$thishost);
    return 1;
  }

  #Default Thresholds
  $t_readhit[$thishost] = 80 if $t_readhit[$thishost] eq "";  
  $t_readhit_sev[$thishost] = "P" if $t_readhit_sev[$thishost] eq "";  
  $t_libhit  = 90;
  $t_dicthit = 90;

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  $oraperfok = 1;

  #---- Fix some vars - START
  $sga_size_mb[$thishost] = int($sga_size[$thishost] / 2**20); 
  if ($db_block_buffers[$thishost] > 0)
  {
    $bmeg = int(($db_block_buffers[$thishost] * $db_block_size[$thishost]) / 2**20);
    $bmsg = "db_block_buffers=$db_block_buffers[$thishost] (${bmeg}M)";
  }
  else
  {
    $bmeg = int($db_cache_size[$thishost] / 2**20);
    $bmsg = "db_cache_size=$db_cache_size[$thishost] (${bmeg}M)";
  }
  if ($bufhitratio_xr[$thishost] > $bufhitratio[$thishost]) 
  { 
    $this_bufhitratio = $bufhitratio_xr[$thishost]; 
  }
  else    
  { 
    $this_bufhitratio = $bufhitratio[$thishost]; 
  }

  $this_bufhitratio_int = int($this_bufhitratio);

  #---- Save some metrics
  &metricsInsert("orantPerf()", $thishost, "ORA_BufHitRatio", ".", $this_bufhitratio);
  &metricsInsert("orantPerf()", $thishost, "ORA_BufHitRatio_Default", ".", $pool_default_hr[$thishost]);
  &metricsInsert("orantPerf()", $thishost, "ORA_BufHitRatio_Recycle", ".", $pool_recycle_hr[$thishost]);
  &metricsInsert("orantPerf()", $thishost, "ORA_BufHitRatio_Keep",    ".", $pool_keep_hr[$thishost]);

  #---- Fix some vars - END

  ##print "bufblkgets=$bufblkgets[$thishost]\n";

  ##print "this_bufhitratio=$this_bufhitratio t=$t_readhit[$thishost]\n";

  if ($bufblkgets[$thishost] =~ /^1844/ ||
      $bufblkgets[$thishost] =~ /^1.844/)
  {
    print "bufblkgets invalid $bufblkgets[$thishost]\n";
    &logit("Buffer Block Gets ($bufblkgets[$thishost]) is invalid 1844* value (Oracle Bug) - Hit Ratio Not Applicable",$thishost);
    $oraperfok = 0; 
  }
  elsif ($bufcongets[$thishost] < 1000000)
  {
    &logit("Buffer Consistent Gets ($bufcongets[$thishost]) <1000000 - Hit Ratio Not Applicable",$thishost);
    $oraperfok = 0; 
  }
  elsif ($bufhitratio[$thishost] < 0 || $bufhitratio[$thishost] > 100)
  {
    &event("P",$thishost,"DB Cache Read Hit Ratio of $bufhitratio[$thishost] is invalid (< 0 or > 100)","BufHitNG","DBA911");
    $oraperfok = 0; 
    system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] NG bufhitratio=$bufhitratio[$thishost] t=$t_readhit[$thishost]' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }
  elsif ($this_bufhitratio < $t_readhit[$thishost])
  {
    &event("$t_readhit_sev[$thishost]",$thishost,"DB Cache Read Hit Ratio of $this_bufhitratio < threshold of $t_readhit[$thishost] - $bmsg","BufHit=${this_bufhitratio_int}%","DBA910");
    $oraperfok = 0; 
    ##system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] LO bufhitratio=$bufhitratio[$thishost] t=$t_readhit[$thishost]' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  $timestamp_rowlimit = 100000;
  if ($timestamp_rows[$thishost] > $timestamp_rowlimit)
  {
    &event("P",$thishost,"DBAMON.TIMESTAMP Has > $timestamp_rowlimit rows ($timestamp_rows[$thishost])","TimeStampRows","DBA909");
    system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] DBAMON.TIMESTAMP has $timestamp_rows[$thishost] rows' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  if ($num_otrace[$thishost] > 0)
  {
    &event("C",$thishost,"$num_otrace[$thishost] ORACLE_HOME/otrace/admin/*.dat Files Found - OTRACE Is ON Which Causes Performance Problems","OTRACEOn","DBA913");
    system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] $num_otrace[$thishost] ORACLE_HOME/otrace/admin/*.dat Files Found' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  if ($sql_trace[$thishost] eq "TRUE")
  {
    &event("C",$thishost,"Instance-Wide SQL_TRACE is set to $sql_trace[$thishost] - This Causes Performance Problems","SQLTraceOn","DBA914");
    #system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] SQL_TRACE=$sql_trace[$thishost]' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  if ($libhitratio[$thishost] < $t_libhit && $libgets[$thishost] > 1000000)
  {
    &event("P",$thishost,"Library Cache Hit Ratio is $libhitratio[$thishost]% (Should Be >= 90%) - SGA Size: $sga_size_mb[$thishost]M - Increase shared_pool_size","LibHitRatio","DBA921");
    #system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] libhitratio=$libhitratio[$thishost]%' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  if ($rollback_wtg[$thishost] >= 1)
  {
    &event("P",$thishost,"Rollback Segment Header Waits Are $rollback_wtg[$thishost]% of Gets (Gets/Waits Ratio > 1.00%) - Add Rollback Segments","RBHdrWaits","DBA923");
  }

  if ($dicthitratio[$thishost] < $t_dicthit && $dictgets[$thishost] > 1000000)
  {
    &event("P",$thishost,"Dictionary Cache Hit Ratio is $dicthitratio[$thishost]% (Should Be >= 90%) - SGA Size: $sga_size_mb[$thishost]M - Increase shared_pool_size","LibHitRatio","DBA922");
    #system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] dicthitratio=$dicthitratio[$thishost]%' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  ##print "oraPerf - $titleraw[$thishost] fb=$free_buffers[$thishost]\n";
  if ($free_buffers[$thishost] > -1 && $free_buffers[$thishost] < 10)
  {
    &event("P",$thishost,"There are fewer than 10 Free DB Cache Buffers (free_buffers=$free_buffers[$thishost]) - It would be beneficial to increase DB Cache Size - $bmsg","NoFreeBuffers","DBA924");
  }

  #
  # Process user exceptions
  #

  $user_exceptions[$thishost] =~ s/\$/\\\$/g;

  ##print "perf ue=$user_exceptions[$thishost]\n";
  @words= split(/ /,$user_exceptions[$thishost]);
  ## print "#words=$#words\n";

  $dfltsys_list = "";
  $dfltsys_sql  = "";
  $dfltsys_cnt  = 0;
  $tempsys_list = "";
  $tempsys_sql  = "";
  $tempsys_cnt  = 0;
  $tempperm_list = "";
  $tempperm_sql  = "";
  $tempperm_cnt  = 0;

  foreach (@words)
  {
    #split this entry
    @subwords= split(/,/,$_);
    ##print "#subwords=$#subwords\n";
    $verb = $subwords[0];
    $user = $subwords[1];
    $dfts = $subwords[2];
    $tmts = $subwords[3];
    ##print "verb=$verb user=$user dfts=$dfts tmts=$tmts\n";

    if ($verb eq "DFLT_SYS:") 
    {
      $dfltsys_list .= "User Exception: User=$user Default_Tablespace=$dfts Temporary_Tablespace=$tmts\n";
      $dfltsys_cnt++;
      $sql = "ALTER USER $user DEFAULT TABLESPACE $good_users_ts[$thishost];";
      $dfltsys_sql  .= "$sql\n";
    }
    if ($verb eq "TEMP_SYS:") 
    {
      $tempsys_list .= "User Exception: User=$user Default_Tablespace=$dfts Temporary_Tablespace=$tmts\n";
      $tempsys_cnt++;
      $sql = "ALTER USER $user TEMPORARY TABLESPACE $good_temp_ts[$thishost];";
      $tempsys_sql  .= "$sql\n";
    }
    if ($verb eq "TEMP_PERM:") 
    {
      $tempperm_list .= "User Exception: User=$user Default_Tablespace=$dfts Temporary_Tablespace=$tmts\n";
      $tempperm_cnt++;
      $sql = "ALTER USER $user TEMPORARY TABLESPACE $good_temp_ts[$thishost];";
      $tempperm_sql  .= "$sql\n";
    }
  }
  
  if ($dfltsys_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $dfltsys_list;
    print TMPFL6 "SQL To Fix: \n<b>$dfltsys_sql\n</b>";
    close(TMPFL6);
    &event("W",$thishost,"$dfltsys_cnt DB Users Found With DEFAULT TABLESPACE Set To SYSTEM","UsersDfltSys","DBA915",$tmpfl6);
    #system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] $dfltsys_cnt Users Found With DEFAULT TABLESPACE = SYSTEM' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  if ($tempsys_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $tempsys_list;
    print TMPFL6 "SQL To Fix: \n<b>$tempsys_sql\n</b>";
    close(TMPFL6);
    &event("W",$thishost,"$tempsys_cnt DB Users Found With TEMPORARY TABLESPACE Set To SYSTEM","UsersTempSys","DBA916",$tmpfl6);
    #system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] $tempsys_cnt Users With TEMPORARY TABLESPACE = SYSTEM' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  if ($tempperm_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $tempperm_list;
    print TMPFL6 "SQL To Fix: \n<b>$tempperm_sql\n</b>";
    close(TMPFL6);
    &event("W",$thishost,"$tempperm_cnt DB Users Found Whose TEMPORARY TABLESPACE Is a PERMANENT Tablespace","UsersTempPerm","DBA917",$tmpfl6);
    #system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] $tempperm_cnt Users With TEMPORARY TABLESPACE = SYSTEM' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  #
  # Process ts exceptions
  #

  ##print "perf ue=$ts_exceptions[$thishost]\n";
  @words= split(/ /,$ts_exceptions[$thishost]);
  ## print "#words=$#words\n";

  $tempperm_list = "";
  $tempperm_cnt  = 0;

  foreach (@words)
  {
    #split this entry
    @subwords= split(/,/,$_);
    ##print "#subwords=$#subwords\n";
    $verb = $subwords[0];
    $ts   = $subwords[1];
    $t1   = $subwords[2];
    $t2   = $subwords[3];
    ##print "verb=$verb ts=$ts \n";

    if ($verb eq "TEMP_PERM:") 
    {
      $tempperm_list .= "Tablespace=$ts \n";
      $tempperm_cnt++;
    }
  }
  
  if ($tempperm_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $tempperm_list;
    close(TMPFL6);
    &event("C",$thishost,"TEMP Tablespace is a PERMANENT Tablespace (It Should Be TEMPORARY)","TSTempPerm","DBA920",$tmpfl6);
    #system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] TEMP is PERM' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  $nf_t_c = 90;
  $nf_t_w = 80;

  if ($nf_pct[$thishost] >= $nf_t_c)
  {
    $msg = sprintf("UX NFILEs %s%% Used - Current Value=%s Kernel Maximum=%s (Critical Threshold=$nf_t_c%%)",$nf_pct[$thishost],$nf_cur[$thishost],$nf_max[$thishost]);
    &event("C",$thishost,"$msg","NFile","DBA461");
    system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] C nf_pct=$nf_pct[$thishost]' $admin_email");
  }
  elsif ($nf_pct[$thishost] >= $nf_t_w)
  {
    $msg = sprintf("UX NFILEs %s%% Used - Current Value=%s Kernel Maximum=%s (Warning Threshold=$nf_t_w%%)",$nf_pct[$thishost],$nf_cur[$thishost],$nf_max[$thishost]);
    &event("W",$thishost,"$msg","NFile","DBA461");
    system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] W nf_pct=$nf_pct[$thishost]' $admin_email");
  }
  else
  {
    $msg = sprintf("OK - %s / %s %s%%",$nf_cur[$thishost],$nf_max[$thishost],$nf_pct[$thishost]);
    &logit($msg,$thishost);
  }

  #---- Make D page
  &logDetails($thishost,"</pre>");
  &logDetails($thishost,"<h3>Oracle Performance Data (Classic View)</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");

  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Buffer Cache Hit Ratio:<td align=right>$f_s $bufhitratio[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Buffer Cache Hit Ratio (Excluding RECYCLE Pool):<td align=right>$f_s $bufhitratio_xr[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Library Cache Hit Ratio:<td align=right>$f_s $libhitratio[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Library Cache Gets:<td align=right>$f_s $libgets[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Dictionary Cache Hit Ratio:<td align=right>$f_s $dicthitratio[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Dictionary Cache Gets:<td align=right>$f_s $dictgets[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Consistent Gets:<td align=right>$f_s $bufcongets[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Buffer Block Gets:<td align=right>$f_s $bufblkgets[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Buffer Physical Reads:<td align=right>$f_s $bufphysreads[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>db_block_buffers:<td align=right>$f_s $db_block_buffers[$thishost] <td>$f_s (8i & Lower)");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>db_cache_size:<td align=right>$f_s $db_cache_size[$thishost] <td>$f_s (9i & Higher))");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Free DB Cache Buffers:<td align=right>$f_s $free_buffers[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>DEFAULT Pool Hit Ratio:<td align=right>$f_s $pool_default_hr[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>RECYCLE Pool Hit Ratio:<td align=right>$f_s $pool_recycle_hr[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>KEEP Pool Hit Ratio:<td align=right>$f_s $pool_keep_hr[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Number of OTRACE .dat Files:<td align=right>$f_s $num_otrace[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Instance SQL_TRACE Setting:<td align=right>$f_s $sql_trace[$thishost]");
  &logDetails($thishost,"<tr bgcolor=white><td>$f_s<b>Rollback Segment Waits/Gets Ratio:<td align=right>$f_s $rollback_wtg[$thishost]");
  # &logDetails($thishost,"<tr><td>$f_s<b>NFILE Current Value:<td align=right>$f_s $nf_cur[$thishost]");
  # &logDetails($thishost,"<tr><td>$f_s<b>NFILE Maximum Value:<td align=right>$f_s $nf_max[$thishost]");
  # &logDetails($thishost,"<tr><td>$f_s<b>NFILE % Used:<td align=right>$f_s $nf_pct[$thishost]");
  &logDetails($thishost,"</table><hr>");

  if ($oraperfok)
  {
    &logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
