# -----------------------------------------------------------------------------
sub sqlTLog
# -----------------------------------------------------------------------------
{
  #----
  #---- This routine uses stacked data
  #----

  ($thishost) = @_;

  my $z = ""; 

  $tot_tlsize = 0; 
  $tot_maxsize = 0; 

  $event_tlog_flag = 0; 

  if ($t_arclog_w[$thishost] eq "N")
  {
    &logit("(Not Selected (T_Arclog_Full: is N)",$thishost);
    return 1;
  }

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  &logit("Starting",$thishost);

  #---- 2011/01/02 BB - Was 95/99
  if ($t_arclog_w[$thishost] eq "") { $t_arclog_w[$thishost] = "80" }
  if ($t_arclog_c[$thishost] eq "") { $t_arclog_c[$thishost] = "90" }
  
  &logDetails($thishost,"</table>");
  &logDetails($thishost,"<br><a name='sqlTLog'> <h3>MSSQL Transaction Log Status</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");

  #---- This was moved to a SUB at the end
  #&logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
  #  <th>$f_s DBName<br>(1 Row for Each TLog File)
  #  <th>$f_s TLog Size<br> (MB Alloc.)
  #  <th>$f_s DB Size<br> (MB Alloc.)
  #  <th>$f_s DB+TLog Size<br> (MB Alloc.)
  #  <th>$f_s TLog Size to<br> DB Size<br> Ratio 
  #  <th>$f_s Simple Recovery Model?
  #  <th>$f_s % Full Internal<br> (DBCC SQLPERF (LOGSPACE))<br>(All TLog Files)
  #  <th>$f_s Max<br>Size<br>(MB)
  #  <th>$f_s % Full vs. Max Size
  #  <th>$f_s Filename
  #  <th>$f_s Drive
  #  <th>$f_s Drive % Full 
  #");
  #&sqlTLog_Header;

  # print "$P TLOG: $dbname $trunc $size $pctused $this_drive_letter $this_drive_pctused $dbp_log_fname $dbp_log_space\n";
  # dbamon_mssql.pl TLOG: master                 Yes    1.24 48.86 E 80.56 E:\\MSSQL7\\data\\mastlog.ldf                            Unlimited
  # dbamon_mssql.pl TLOG: WSS_Content_Frontier_5 No  3149.31  0.82 L       L:\\MSSQL.1\\MSSQL\\Data\\WSS_Content_Frontier_5_log.LDF 2147483.65
  
  $tl_dbname_last = ""; 

  foreach (split('\n',$tlogdata[$thishost]))
  {
    @words = split;
    ##$tl_dbname   = lc $words[2];   Leave the case 2010/11/25
    $tl_dbname   = $words[2]; 
    $tl_trunc    = $words[3]; 
    $tl_tlsize   = $words[4]; 
    $tl_pctused  = $words[5]; 
    $tl_drive    = $words[6]; 
    $tl_drivepct = $words[7]; 
    $tl_filename = $words[8]; 
    $tl_growth   = $words[9]; 
    $tl_lrwd{$tl_dbname} = $words[10]; 

    ##print "DEBUG1 - tl_dbname=$tl_dbname tl_growth=$tl_growth\n";
 
    #---- If this is the first TLOG for the NEXT DB, take totals from LAST PROCESSED DB
    #----   This is where all events are processed also
    if ($tl_dbname_last && $tl_dbname ne $tl_dbname_last) 
    {
      #---- DB-wide report and all events
      &sqlTLog_LL; 
    }

    #----- Do heading for this NEW DBname
    if ($tl_dbname ne $tl_dbname_last) 
    {
      #my $z = "<tr bgcolor=$table_headbgcolor>
      # <td nowrap colspan=12>$f_s &nbsp; <b>Database: ${tl_dbname}:</b> 
      # "; 
      &sqlTLog_Header;
      #&logDetails($thishost,$z);
    }

    $tot_tlsize += $tl_tlsize; 
    $tot_maxsize += $tl_growth; 

    #---- Some events for this ONE TLOG file
    if ($tl_growth eq "Unlimited")
    {
      $this_tl_full_vs_limit = -1;
      #---- USER Event
      $ev_cat = "Mgmt";
      &event("U",$thishost,"DBName=$tl_dbname - TLog Is MAXSIZE=Unlimited","TLog-Unlimited","DBA200");
    }
    #---- Changed to elsif 2012/10/26
    elsif ($tl_growth eq "FixedSize")
    {
      $this_tl_full_vs_limit = -1;
      #---- USER Event
      $ev_cat = "Mgmt";
      &event("W",$thishost,"DBName=$tl_dbname - TLog Is MAXSIZE=Fixed (No Growth)","TLog-FixedSize","DBA200");
    }
    elsif ($tl_growth == 0)
    {
      $this_tl_full_vs_limit = -2;
    }
    else
    {
      $this_tl_full_vs_limit = sprintf "%.2f",($tl_tlsize / $tl_growth) * 100;
    }

    #---- Try to get rid of the doubleslashes in the filenames
    $tl_filename =~ s/\\\\/\\/g;

    my $ztotsize = $db_info_tl_dbsize[$thishost]{$tl_dbname} + $tl_tlsize;
    my $zdbsize  = $db_info_tl_dbsize[$thishost]{$tl_dbname} ;

    $z = "<tr bgcolor=$table_rowcolor> 
      <td>$f_s <b> $tl_dbname </b>
      <td align=right>$f_s $tl_tlsize
      <td align=right>$f_s 
      <td align=right>$f_s 
      <td align=right>$f_s 
      <td>$f_s 
      <td align=right>$f_s 
      <td>$f_s $tl_growth
      <td align=right>$f_s $this_tl_full_vs_limit
      <td nowrap>$f_s <b> $tl_filename </b>
      <td>$f_s $tl_drive
      <td align=right>$f_s ${tl_drivepct}% 
      <td>$f_s $tl_lrwd{$tl_dbname}
    ";
    &logDetails($thishost,$z);

    if ($debug_294 eq "Y")
    {
      print "$titleraw[$thishost] - tl_dbname=$tl_dbname tl_trunc=$tl_trunc tl_tlsize=$tl_tlsize tl_pctused=$tl_pctused tl_drive=$tl_drive\n";
      print "    tl_drivepct=$tl_drivepct tl_filename=$tl_filename tl_growth=$tl_growth\n";
      print "    this_tl_full_vs_limit=$this_tl_full_vs_limit\n";
    }

    ##&metricsInsert("sqlTLog()",$thishost,"TLOG_PCT_VS_MAX",$tl_dbname,$this_tl_full_vs_limit);

    #---- Save for next iter
    $tl_dbname_last = $tl_dbname; 
    $tl_trunc_last  = $tl_trunc; 
    $tl_pctused_last  = $tl_pctused; 
  }
  &logit("After read array",$thishost);

  #---- Final TOTAL line after last row was read
  &sqlTLog_LL;

  #---- Table end
  &logDetails($thishost,"</table><hr>");
}
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
sub sqlTLog_LL
# -----------------------------------------------------------------------------
{
  my $z = ""; 

  &logit("sqlTLog_LL Start",$thishost);

  #---- This is run to total ALL TLOG Files for each DB. This is where I should calculate things like TLOG/DB size ratio, etc.
  #----   and where I should do all TLOG events. 

  #---- Total line for this DB
  my $zdbsize      = $db_info_tl_dbsize[$thishost]{$tl_dbname_last} - $tot_tlsize; 
  my $ztotsize     = $zdbsize + $tot_tlsize;
  my $ztlogdbratio = sprintf "%.2f",($tot_tlsize / $zdbsize);

  $zdbsize      = 0 if $zdbsize < 0; 
  $ztlogdbratio = 0 if $ztlogdbratio < 0; 

  my $zcolor_ratio   = 0; 
  my $zcolor_pctused = 0; 
  my $event_sev      = "";
  my $event_sev_long = "";
  my $event_pct      = 0;

  #----
  #---- Process any events
  #----

  #---- EVENT: DB size / TLOG size ratio
  $tl_ratio_threshold = 5;
  &metricsCurrent("sqlUp()",$thishost,"TLOG_RATIO",$tl_dbname_last,$ztlogdbratio,'',$tl_ratio_threshold,"Size of TLOG Divided By Size of DB is $ztlogdbratio");
  if ($ztlogdbratio >= $tl_ratio_threshold && $ztotsize >= 1000)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "DBName:                $tl_dbname_last\n";
    print TMPFL2 "TLog_Size:             $tot_tlsize (mB)\n";
    print TMPFL2 "DBSize:                $zdbsize (mB)\n";
    print TMPFL2 "TLogSize_DBSize_Ratio: $ztlogdbratio\n";
    close(TMPFL2);
    $ev_cat = "Mgmt";
    &event("C",
      $thishost,
      "DB=$tl_dbname_last - TLog is $ztlogdbratio times DB size and TLog is >= 1gB (DBSize=$zdbsize (mB) TLSize=$tot_tlsize (mB) Threshold=$tl_ratio_threshold)",
      "TLog-Size-Ratio",
      "DBA656",
      $tmpfl2);
    $zcolor_ratio = "pink"; 
    $event_tlog_flag = 1; 
  }
  else
  {
    $zcolor_ratio = "lime"; 
  }

  #---- METRICS for this DB
  &metricsInsert("sqlTLog()",$thishost,"TLOG_PCT_INT",$tl_dbname_last,$tl_pctused_last);

  #---- 1st TOTAL line for this DB
  $z = "<tr bgcolor=$table_headbgcolor>
   <td nowrap align=right>$f_s <b> Totals: </b> 
   <td align=right>$f_s <b> $tot_tlsize </b> 
   <td align=right>$f_s <b> $zdbsize </b>
   <td align=right>$f_s <b> $ztotsize </b> 
   <td align=right bgcolor=$zcolor_ratio>$f_s <b> $ztlogdbratio </b>
   <td >$f_s            <b> $tl_trunc_last </b>
   <td align=right zgcolor=$zcolor_pctused>$f_s <b> $tl_pctused_last  </b>
   <td align=right >$f_s <b> $tot_maxsize  </b>
   <td colspan=4> &nbsp; 
   "; 
  &logDetails($thishost,$z);

  #---- 2nd total line
  my $net_used = ($tl_pctused_last / 100) * $tot_tlsize; 
  $net_used = sprintf "%.2f", $net_used;

  $z = "<tr bgcolor=$table_headbgcolor>
   <td nowrap align=right>$f_s <b> Net TLog Used Space (MB): </b> 
   <td nowrap align=right>$f_s <b> $net_used </b> 
   <td align=left colspan=10>$f_s &nbsp; (DBCC SQLPERF (LOGSPACE) Percent Used: $tl_pctused_last * Total TLog Size MB: $tot_tlsize = Net Used MB: $net_used)
   "; 
  &logDetails($thishost,$z);

  #---- 3rd total line
  my $net_pct_full = -99; 
  if ($tot_maxsize > 0) 
  {
    $net_pct_full = sprintf("%.2f", (($net_used / $tot_maxsize) * 100 )); 
  }
  else
  {
    $net_pct_full = $tl_pctused_last; 
  }

  $z = "<tr bgcolor=$table_headbgcolor>
   <td nowrap align=right>$f_s <b> Net TLog % Full vs. MaxSize: </b> 
   <td nowrap align=right>$f_s <b> ${net_pct_full}% </b> 
   <td align=left colspan=10>$f_s &nbsp; (Net TLog Used Space (MB): $net_used / Total Maxsize (MB): $tot_maxsize) 
   "; 
  &logDetails($thishost,$z);

  #---- METRICS for this DB
  &metricsInsert("sqlTLog()",$thishost,"TLOG_NET_PCT_FULL",$tl_dbname_last,$net_pct_full);

  my $zcompare = -99;
  #---- Event line?:
  #---- EVENT: TLOG PCT USED 

  #---- OLD Way:
  #  $zcompare = $tl_pctused_last; 
  #---- NEW Way:
  $zcompare = $net_pct_full; 
  
  if ($zcompare >= $t_arclog_c[$thishost])
  {
    $event_sev      = "C";
    $event_sev_long = "Critical";
    $event_pct      = $t_arclog_c[$thishost];
    $zcolor_pctused = "pink";
  }
  elsif ($zcompare >= $t_arclog_w[$thishost])
  {
    $event_sev      = "W";
    $event_sev_long = "Warning";
    $event_pct      = $t_arclog_w[$thishost];
    $zcolor_pctused = "yellow";
  }
  else 
  {
    $event_sev      = "";
    $zcolor_pctused = "lime";
    $event_text     = "OK - No Event - Val=$zcompare W_Threshold=$t_arclog_w[$thishost] C_Threshold=$t_arclog_c[$thishost]"; 
  } 

  if ($event_sev ne "") 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "DBName:                   $tl_dbname_last\n";
    print TMPFL2 "DBSize:                   $zdbsize (mB)\n";
    print TMPFL2 "TLog_Size:                $tot_tlsize (mB) (Total Size of all TLog Files)\n";
    print TMPFL2 "TLogSize_DBSize_Ratio:    $ztlogdbratio    (TLog Size / DB Size)\n";
    print TMPFL2 "TLog_Pct_Used_Internal_%: $tl_pctused_last (From DBCC SQLPERF (LOGSPACE)\n";
    print TMPFL2 "TLog_Net_Used_Space_MB:   $net_used        (A)\n";
    print TMPFL2 "TLog_Total_Maxsize_MB:    $tot_maxsize     (B)\n";
    print TMPFL2 "TLog_Net_Percent_Used:    ${net_pct_full}% (A / B)\n";
    print TMPFL2 "Log_Reuse_Wait_Desc:      $tl_lrwd{$tl_dbname_last}  (Current value from Sys.Databases)\n";
    close(TMPFL2);

    #---- Old
    ##my $tl_pctused_int = int($tl_pctused_last); 
    ## $event_text = "DB=$tl_dbname_last - TLog (Used Space) is Internally ${tl_pctused_int}% Full ($event_sev_long Threshold of $event_pct% exceeded - TLSize=${tot_tlsize}(mB))";
    ##$event_text = "DB=$tl_dbname_last - TLog (Used Space) is ${zcompare}% Full vs. Total Max Size ($event_sev_long Threshold of $event_pct% exceeded - TLSize=${tot_tlsize}(mB) TotMaxSize=${tot_maxsize}(mB))";
    #---- New
    my $zcompare_int = int($zcompare); 
    $event_text = "DB=$tl_dbname_last - TLog (Used Space) is ${zcompare_int}% Full vs. Total Max Size ($event_sev_long Threshold of $event_pct% exceeded - TLSize=${tot_tlsize}(mB) TotMaxSize=${tot_maxsize}(mB) LogReuseWaitDesc=$tl_lrwd{$tl_dbname_last})";
    $ev_cat = "Avail";
    &event("$event_sev",$thishost,$event_text,"TLogFull-${event_sev_long}-Internal","DBA657",$tmpfl2);
    $event_tlog_flag = 1; 
  }

  $z = "<tr bgcolor=$table_headbgcolor>
   <td nowrap align=right>$f_s <b> TLOG Full Event (If Any): </b> 
   <td align=left colspan=11 bgcolor=$zcolor_pctused>$f_s <b>$event_text</b>
   "; 
  &logDetails($thishost,$z);

  #---- Blank line
  &logDetails($thishost,"<tr><td colspan=13> &nbsp; ");

  #---- Log file entries
  &logit("DB=($tl_dbname_last) - TLog_Pct_Full=$tl_pctused_last TLog_Size=$tot_tlsize DBSize=$zdbsize",$thishost); 
  &logit("  Simple_Recov=$tl_trunc_last TLog_Drive_Pct_Full_INT=$tl_pctused_last",$thishost);

  #---- Clear BY-DB totals
  $tot_tlsize = 0; 
  $tot_maxsize = 0; 

  &logit("sqlTLog_LL Done",$thishost);
}

# -----------------------------------------------------------------------------
sub sqlTLog_Header
# -----------------------------------------------------------------------------
{
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th><span $style_th> Database:<br>$tl_dbname<br><br>(1 Row for Each TLog File)
    <th><span $style_th> TLog Size<br> (MB Alloc.)
    <th><span $style_th> DB Size<br> (MB Alloc.)
    <th><span $style_th> DB+TLog Size<br> (MB Alloc.)
    <th><span $style_th> TLog Size to<br> DB Size<br> Ratio 
    <th><span $style_th> Simple Recovery Model?
    <th><span $style_th> % Full Internal<br> (DBCC SQLPERF (LOGSPACE))<br>(All TLog Files)
    <th><span $style_th> Max<br>Size<br>(MB)
    <th><span $style_th> % Full<br>vs.<br>Max Size
    <th><span $style_th> Filename
    <th><span $style_th> Drive
    <th><span $style_th> Drive % Full 
    <th><span $style_th> Log Reuse<br>Wait Desc
  ");
}

1;
