#set P = SingleLine

#shell #processrows
  date +%Y/%m/%d-%H:%M:%S
#endshell
#call $shellrow ( thedate )

#shell #processrows
  echo $THIS_TARGET 
#endshell
#call $shellrow ( thetarget )

#shell #processrows
  echo $DBAMON_PL_FILE 
#endshell
#call $shellrow ( inputfile )

#shell #processrows
  echo $DBAMON_PL_FILE_PNG
#endshell
#call $shellrow ( png_file )

#shell #processrows
  echo $DBAMON_PL_INSTANCE 
#endshell
#call $shellrow ( dbamon_instance )

#shell #processrows
  echo $DBAMON_PL_METRIC 
#endshell
#call $shellrow ( dbamon_metric )

#shell #processrows
  echo $DBAMON_PL_MOVINGAVGCOUNT 
#endshell
#call $shellrow ( dbamon_movingavg_count )

#shell #processrows
  echo $DBAMON_PL_LASTVAL 
#endshell
#call $shellrow ( dbamon_lastval )

#proc getdata
  file: @inputfile

#proc settings
  numbernotation: us

#proc page
//  textsize: 10
//  font: times
//  outfilename: @P.jpeg
  outfilename: @png_file
  backgroundcolor: xrgb(fffff0)
  pagesize: 8.5 5.2
  titledetails: align=left  adjust=-0.8,-4.35 size=8
  title: DBAmon / Ploticus - Created=@thedate PL_Program=@P Obs=@NRECORDS LastValue=@dbamon_lastval

// #proc image
//   file: ./hplogo2.gif
//   location: 0.1 0.8 
//   width: 65
//   height: 55


// Sample
//#proc areadef
//rectangle: 1 1 5 3
//xscaletype: date mmddyy
//xautorange: datafield=dt
//yautorange: datafield=count incmult=2.0 lowfix=0
//xaxis.stubs: inc 1 month
//xaxis.stubformat: Mmmyy
//yaxis.stubs: inc

#proc areadef
  title: Instance: @dbamon_instance\n
  titledetails: align=center size=13 adjust=0,0.3 style=N
  title2: Metric: @dbamon_metric \n
  title2details: align=center size=9 adjust=0,0.1 style=N
  xscaletype: datetime yyyy/mm/dd.hh:mm
  xautorange: datafield=1
  yautorange: datafield=2
  rectangle: 1 1 7 3.8

  xaxis.stubvert: yes 
  xaxis.stubs: inc datetimematic
//  xaxis.stubs: datetimematic 
//  xaxis.minortics: none 
//  xaxis.labeldistance: 1.6
  xaxis.grid: width=0.1  style=1
  xaxis.autodays: no 
  xaxis.autoyears: no 
  xaxis.automonths: no 
  xaxis.labeldetails: size=8 color=green 
  xaxis.stubformat: yyyy/mm/dd.hh:mm

  yaxis.labeldetails: size=7 color=black 
  yaxis.labeldistance: 0.7
  yaxis.grid: width=0.1  style=1
  yaxis.stubs: inc
//  yaxis.label: @dbamon_metric 

#proc lineplot
  xfield: 1
  yfield: 2
//OFF24  legendlabel: Metric\nValue
  linedetails: color=red width=0.8 
  pointsymbol: shape=circle style=fill fillcolor=red radius=0.018 
  
// compute and render moving average curve using proc curvefit
 #proc curvefit
   xfield: 1
   yfield: 2
   order: @dbamon_movingavg_count
   curvetype: movingavg 
   maxinpoints: 1000000
   legendlabel: @dbamon_movingavg_count Obs.\nMoving\nAverage
   linedetails: color=green width=1.0 

#proc legend
  location: max+0.7 max-0.5 
  format: down

//  xaxis.stubs: list Jul\nAug\nSep\nOct\nNov\nDec
//  xrange: 2010/01 2010/12
//  xaxis.autoyears: yyyy 
//  xaxis.stubs: inc 1  month
//  xaxis.stubrange: 201007 201012
//  xaxis.stubformat: YYYY/MM
//  xaxis.automonths: mm 
//  font: clb9x15
//  titledetails: align=right  adjust=0.3,-3.15 size=7
//  frame: bevel
//  yaxis.stubs: incremental 500
//  xaxis.label: Date 
//  xaxis.labeldistance: 0.9
//  pointsymbol: shape=pixtriangle  style=filled radius=0.02 color=blue
