-- Start

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS
    WHERE table_schema = 'dbamon' AND TABLE_NAME = 'metrics_daily' AND COLUMN_NAME = 'sum')
BEGIN
   ALTER TABLE [dbamon].[metrics_daily] ADD [sum] numeric(15,2) NOT NULL default 0
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS
    WHERE table_schema = 'dbamon' AND TABLE_NAME = 'metrics_hourly' AND COLUMN_NAME = 'sum')
BEGIN
   ALTER TABLE [dbamon].[metrics_hourly] ADD [sum] numeric(15,2) NOT NULL default 0
END

-- 2013/08/18 New ID11-20 columns

-- 2014/01/19 Change column definition for MSSQL_BACKUP:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'mssql_backup' and column_name = 'server') != 255
BEGIN
ALTER TABLE dbamon.mssql_backup ALTER COLUMN server VARCHAR(255)
END

-- 2014/01/19 Change column definition for INSTANCES:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'instances' and column_name = 'instance') != 255
BEGIN
  ----Diable Index
  drop index instances_x1 on dbamon.instances;
  ---- Alter column
  ALTER TABLE dbamon.instances ALTER COLUMN instance VARCHAR(255);
  ----Enable Index
  create index instances_x1 on dbamon.instances (instance, dbamonmode);
END

-- 2014/01/27 Change column definition for summary_detail:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'summary_detail' and column_name = 'title') != 255
BEGIN
  ---- Alter column
  ALTER TABLE dbamon.summary_detail ALTER COLUMN title VARCHAR(255);
END

-- 2014/04/13 Change column definition for METRICS_DETAIL:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'metrics_detail' and column_name = 'category') < 255
BEGIN
  ---- Alter column
  ALTER TABLE dbamon.metrics_detail ALTER COLUMN category VARCHAR(255);
END

-- 2014/04/13 Change column definition for METRICS_CURRENT:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'metrics_current' and column_name = 'category') < 255
BEGIN
  ---- Alter column
  ALTER TABLE dbamon.metrics_current ALTER COLUMN category VARCHAR(255);
END

-- 2014/04/13 Change column definition for METRICS_DAILY:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'metrics_daily' and column_name = 'category') < 255
BEGIN
  ---- Alter column
  ALTER TABLE dbamon.metrics_daily ALTER COLUMN category VARCHAR(255);
END

-- 2014/04/13 Change column definition for METRICS_HOURLY:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'metrics_hourly' and column_name = 'category') < 255
BEGIN
  ---- Alter column
  ALTER TABLE dbamon.metrics_hourly ALTER COLUMN category VARCHAR(255);
END

-- 2015/01/01 Change column definition for INSTANCES.MODEL:
if (select 
CHARACTER_MAXIMUM_LENGTH from INFORMATION_SCHEMA.COLUMNS
where 
table_schema = 'dbamon' and table_name = 'instances' and column_name = 'model') != 64
BEGIN
  ---- Alter column
  ALTER TABLE dbamon.instances ALTER COLUMN model VARCHAR(64);
END

-- 2017/07/15 New Title1 and Title2 columns in instances
IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE table_schema = 'dbamon' AND TABLE_NAME = 'instances' AND COLUMN_NAME = 'title1')
BEGIN
   ALTER TABLE [dbamon].[instances] ADD [Title1] VARCHAR(80) NULL; 
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE table_schema = 'dbamon' AND TABLE_NAME = 'instances' AND COLUMN_NAME = 'title2')
BEGIN
   ALTER TABLE [dbamon].[instances] ADD [Title2] VARCHAR(80) NULL; 
END

-- 2017/11/12 New KBNUM column in SWVER
IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE table_schema = 'dbamon' AND TABLE_NAME = 'swver' AND COLUMN_NAME = 'swver_kbnum')
BEGIN
   ALTER TABLE [dbamon].[swver] ADD [swver_kbnum] VARCHAR(80) NULL; 
END

-- End
